//
// org.osid.OSID
//
//     Specifies the OSID definition for org.osid.OSID.
//
// Copyright (C) 2002-2004, 2006-2008 Massachusetts Institute of Technology. 
// 
// Copyright (C) 2009-2012 Ingenescus. All Rights Reserved. 
//
//     This Work is being provided by the copyright holder(s) subject to the 
//     following license. By obtaining, using and/or copying this Work, you 
//     agree that you have read, understand, and will comply with the 
//     following terms and conditions. 
//     
//     Permission to use, copy and distribute unmodified versions of this 
//     Work, for any purpose, without fee or royalty is hereby granted, 
//     provided that you include the above copyright notices and the terms of 
//     this license on ALL copies of the Work or portions thereof. 
//     
//     You may modify or create Derivatives of this Work only for your 
//     internal purposes. You shall not distribute or transfer any such 
//     Derivative of this Work to any location or to any third party. For the 
//     purposes of this license, "Derivative" shall mean any derivative of the 
//     Work as defined in the United States Copyright Act of 1976, such as a 
//     translation or modification. 
//     
//     This Work and the information contained herein is provided on an "AS 
//     IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
//     BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
//     PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
//     OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
//     LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
//     FROM, OUT OF OR IN CONNECTION WITH THE WORK OR THE USE OR OTHER 
//     DEALINGS IN THE WORK. 
//     
//     The export of software employing encryption technology may require a 
//     specific license from the United States Government. It is the 
//     responsibility of any person or organization contemplating export to 
//     obtain such a license before exporting this Work. 
//

package org.osid;


/**
 *  This enumeration contains the list of OSIDs. 
 */

public enum OSID {

    /** The Acknowledgement Open Service Interface Definition. */
    ACKNOWLEDGEMENT("acknowledgement", "org.osid.acknowledgement", "org.osid.acknowledgement.AcknowledgementManager", "org.osid.acknowledgement.AcknowledgementProxyManager", "The Acknowledgement Open Service Interface Definition."),

    /** The Assessment Open Service Interface Definition. */
    ASSESSMENT("assessment", "org.osid.assessment", "org.osid.assessment.AssessmentManager", "org.osid.assessment.AssessmentProxyManager", "The Assessment Open Service Interface Definition."),

    /** The Authentication Open Service Interface Definition. */
    AUTHENTICATION("authentication", "org.osid.authentication", "org.osid.authentication.AuthenticationManager", "org.osid.authentication.AuthenticationProxyManager", "The Authentication Open Service Interface Definition."),

    /** The Authorization Open Service Interface Definition. */
    AUTHORIZATION("authorization", "org.osid.authorization", "org.osid.authorization.AuthorizationManager", "org.osid.authorization.AuthorizationProxyManager", "The Authorization Open Service Interface Definition."),

    /** The Bidding Open Service Interface Definition. */
    BIDDING("bidding", "org.osid.bidding", "org.osid.bidding.BiddingManager", "org.osid.bidding.BiddingProxyManager", "The Bidding Open Service Interface Definition."),

    /** The Billing Open Service Interface Definition. */
    BILLING("billing", "org.osid.billing", "org.osid.billing.BillingManager", "org.osid.billing.BillingProxyManager", "The Billing Open Service Interface Definition."),

    /** The Blogging Open Service Interface Definition. */
    BLOGGING("blogging", "org.osid.blogging", "org.osid.blogging.BloggingManager", "org.osid.blogging.BloggingProxyManager", "The Blogging Open Service Interface Definition."),

    /** The Calendaring Open Service Interface Definition. */
    CALENDARING("calendaring", "org.osid.calendaring", "org.osid.calendaring.CalendaringManager", "org.osid.calendaring.CalendaringProxyManager", "The Calendaring Open Service Interface Definition."),

    /** The Cataloging Open Service Interface Definition. */
    CATALOGING("cataloging", "org.osid.cataloging", "org.osid.cataloging.CatalogingManager", "org.osid.cataloging.CatalogingProxyManager", "The Cataloging Open Service Interface Definition."),

    /** The Checklist Open Service Interface Definition. */
    CHECKLIST("checklist", "org.osid.checklist", "org.osid.checklist.ChecklistManager", "org.osid.checklist.ChecklistProxyManager", "The Checklist Open Service Interface Definition."),

    /** The Commenting Open Service Interface Definition. */
    COMMENTING("commenting", "org.osid.commenting", "org.osid.commenting.CommentingManager", "org.osid.commenting.CommentingProxyManager", "The Commenting Open Service Interface Definition."),

    /** The Communication Open Service Interface Definition. */
    COMMUNICATION("communication", "org.osid.communication", "org.osid.communication.CommunicationManager", "org.osid.communication.CommunicationProxyManager", "The Communication Open Service Interface Definition."),

    /** The Configuration Open Service Interface Definition. */
    CONFIGURATION("configuration", "org.osid.configuration", "org.osid.configuration.ConfigurationManager", "org.osid.configuration.ConfigurationProxyManager", "The Configuration Open Service Interface Definition."),

    /** The Contact Open Service Interface Definition. */
    CONTACT("contact", "org.osid.contact", "org.osid.contact.ContactManager", "org.osid.contact.ContactProxyManager", "The Contact Open Service Interface Definition."),

    /** The Control Open Service Interface Definition. */
    CONTROL("control", "org.osid.control", "org.osid.control.ControlManager", "org.osid.control.ControlProxyManager", "The Control Open Service Interface Definition."),

    /** The Course Open Service Interface Definition. */
    COURSE("course", "org.osid.course", "org.osid.course.CourseManager", "org.osid.course.CourseProxyManager", "The Course Open Service Interface Definition."),

    /** The Dictionary Open Service Interface Definition. */
    DICTIONARY("dictionary", "org.osid.dictionary", "org.osid.dictionary.DictionaryManager", "org.osid.dictionary.DictionaryProxyManager", "The Dictionary Open Service Interface Definition."),

    /** The Filing Open Service Interface Definition. */
    FILING("filing", "org.osid.filing", "org.osid.filing.FilingManager", "org.osid.filing.FilingProxyManager", "The Filing Open Service Interface Definition."),

    /** The Financials Open Service Interface Definition. */
    FINANCIALS("financials", "org.osid.financials", "org.osid.financials.FinancialsManager", "org.osid.financials.FinancialsProxyManager", "The Financials Open Service Interface Definition."),

    /** The Forum Open Service Interface Definition. */
    FORUM("forum", "org.osid.forum", "org.osid.forum.ForumManager", "org.osid.forum.ForumProxyManager", "The Forum Open Service Interface Definition."),

    /** The Grading Open Service Interface Definition. */
    GRADING("grading", "org.osid.grading", "org.osid.grading.GradingManager", "org.osid.grading.GradingProxyManager", "The Grading Open Service Interface Definition."),

    /** The Hierarchy Open Service Interface Definition. */
    HIERARCHY("hierarchy", "org.osid.hierarchy", "org.osid.hierarchy.HierarchyManager", "org.osid.hierarchy.HierarchyProxyManager", "The Hierarchy Open Service Interface Definition."),

    /** The Hold Open Service Interface Definition. */
    HOLD("hold", "org.osid.hold", "org.osid.hold.HoldManager", "org.osid.hold.HoldProxyManager", "The Hold Open Service Interface Definition."),

    /** The Id Open Service Interface Definition. */
    ID("id", "org.osid.id", "org.osid.id.IdManager", "org.osid.id.IdProxyManager", "The Id Open Service Interface Definition."),

    /** The Inquiry Open Service Interface Definition. */
    INQUIRY("inquiry", "org.osid.inquiry", "org.osid.inquiry.InquiryManager", "org.osid.inquiry.InquiryProxyManager", "The Inquiry Open Service Interface Definition."),

    /** The Installation Open Service Interface Definition. */
    INSTALLATION("installation", "org.osid.installation", "org.osid.installation.InstallationManager", "org.osid.installation.InstallationProxyManager", "The Installation Open Service Interface Definition."),

    /** The Inventory Open Service Interface Definition. */
    INVENTORY("inventory", "org.osid.inventory", "org.osid.inventory.InventoryManager", "org.osid.inventory.InventoryProxyManager", "The Inventory Open Service Interface Definition."),

    /** The Journaling Open Service Interface Definition. */
    JOURNALING("journaling", "org.osid.journaling", "org.osid.journaling.JournalingManager", "org.osid.journaling.JournalingProxyManager", "The Journaling Open Service Interface Definition."),

    /** The Learning Open Service Interface Definition. */
    LEARNING("learning", "org.osid.learning", "org.osid.learning.LearningManager", "org.osid.learning.LearningProxyManager", "The Learning Open Service Interface Definition."),

    /** The Locale Open Service Interface Definition. */
    LOCALE("locale", "org.osid.locale", "org.osid.locale.LocaleManager", "org.osid.locale.LocaleProxyManager", "The Locale Open Service Interface Definition."),

    /** The Logging Open Service Interface Definition. */
    LOGGING("logging", "org.osid.logging", "org.osid.logging.LoggingManager", "org.osid.logging.LoggingProxyManager", "The Logging Open Service Interface Definition."),

    /** The Mapping Open Service Interface Definition. */
    MAPPING("mapping", "org.osid.mapping", "org.osid.mapping.MappingManager", "org.osid.mapping.MappingProxyManager", "The Mapping Open Service Interface Definition."),

    /** The Messaging Open Service Interface Definition. */
    MESSAGING("messaging", "org.osid.messaging", "org.osid.messaging.MessagingManager", "org.osid.messaging.MessagingProxyManager", "The Messaging Open Service Interface Definition."),

    /** The Metering Open Service Interface Definition. */
    METERING("metering", "org.osid.metering", "org.osid.metering.MeteringManager", "org.osid.metering.MeteringProxyManager", "The Metering Open Service Interface Definition."),

    /** The Offering Open Service Interface Definition. */
    OFFERING("offering", "org.osid.offering", "org.osid.offering.OfferingManager", "org.osid.offering.OfferingProxyManager", "The Offering Open Service Interface Definition."),

    /** The Ontology Open Service Interface Definition. */
    ONTOLOGY("ontology", "org.osid.ontology", "org.osid.ontology.OntologyManager", "org.osid.ontology.OntologyProxyManager", "The Ontology Open Service Interface Definition."),

    /** The Orchestration Open Service Interface Definition. */
    ORCHESTRATION("orchestration", "org.osid.orchestration", "org.osid.orchestration.OrchestrationManager", "org.osid.orchestration.OrchestrationProxyManager", "The Orchestration Open Service Interface Definition."),

    /** The Ordering Open Service Interface Definition. */
    ORDERING("ordering", "org.osid.ordering", "org.osid.ordering.OrderingManager", "org.osid.ordering.OrderingProxyManager", "The Ordering Open Service Interface Definition."),

    /** The Personel Open Service Interface Definition. */
    PERSONNEL("personnel", "org.osid.personnel", "org.osid.personnel.PersonnelManager", "org.osid.personnel.PersonnelProxyManager", "The Personel Open Service Interface Definition."),

    /** The Process Open Service Interface Definition. */
    PROCESS("process", "org.osid.process", "org.osid.process.ProcessManager", "org.osid.process.ProcessProxyManager", "The Process Open Service Interface Definition."),

    /** The Profile Open Service Interface Definition. */
    PROFILE("profile", "org.osid.profile", "org.osid.profile.ProfileManager", "org.osid.profile.ProfileProxyManager", "The Profile Open Service Interface Definition."),

    /** The Provisioning Open Service Interface Definition. */
    PROVISIONING("provisioning", "org.osid.provisioning", "org.osid.provisioning.ProvisioningManager", "org.osid.provisioning.ProvisioningProxyManager", "The Provisioning Open Service Interface Definition."),

    /** The Proxy Open Service Interface Definition. */
    PROXY("proxy", "org.osid.proxy", "org.osid.proxy.ProxyManager", "org.osid.proxy.ProxyProxyManager", "The Proxy Open Service Interface Definition."),

    /** The Recipe Open Service Interface Definition. */
    RECIPE("recipe", "org.osid.recipe", "org.osid.recipe.RecipeManager", "org.osid.recipe.RecipeProxyManager", "The Recipe Open Service Interface Definition."),

    /** The Recognition Open Service Interface Definition. */
    RECOGNITION("recognition", "org.osid.recognition", "org.osid.recognition.RecognitionManager", "org.osid.recognition.RecognitionProxyManager", "The Recognition Open Service Interface Definition."),

    /** The Relationship Open Service Interface Definition. */
    RELATIONSHIP("relationship", "org.osid.relationship", "org.osid.relationship.RelationshipManager", "org.osid.relationship.RelationshipProxyManager", "The Relationship Open Service Interface Definition."),

    /** The Repository Open Service Interface Definition. */
    REPOSITORY("repository", "org.osid.repository", "org.osid.repository.RepositoryManager", "org.osid.repository.RepositoryProxyManager", "The Repository Open Service Interface Definition."),

    /** The Resource Open Service Interface Definition. */
    RESOURCE("resource", "org.osid.resource", "org.osid.resource.ResourceManager", "org.osid.resource.ResourceProxyManager", "The Resource Open Service Interface Definition."),

    /** The Resourcing Open Service Interface Definition. */
    RESOURCING("resourcing", "org.osid.resourcing", "org.osid.resourcing.ResourcingManager", "org.osid.resourcing.ResourcingProxyManager", "The Resourcing Open Service Interface Definition."),

    /** The Room Open Service Interface Definition. */
    ROOM("room", "org.osid.room", "org.osid.room.RoomManager", "org.osid.room.RoomProxyManager", "The Room Open Service Interface Definition."),

    /** The Rules Open Service Interface Definition. */
    RULES("rules", "org.osid.rules", "org.osid.rules.RulesManager", "org.osid.rules.RulesProxyManager", "The Rules Open Service Interface Definition."),

    /** The Search Open Service Interface Definition. */
    SEARCH("search", "org.osid.search", "org.osid.search.SearchManager", "org.osid.search.SearchProxyManager", "The Search Open Service Interface Definition."),

    /** The Sequencing Open Service Interface Definition. */
    SEQUENCING("sequencing", "org.osid.sequencing", "org.osid.sequencing.SequencingManager", "org.osid.sequencing.SequencingProxyManager", "The Sequencing Open Service Interface Definition."),

    /** The Subscription Open Service Interface Definition. */
    SUBSCRIPTION("subscription", "org.osid.subscription", "org.osid.subscription.SubscriptionManager", "org.osid.subscription.SubscriptionProxyManager", "The Subscription Open Service Interface Definition."),

    /** The Topology Open Service Interface Definition. */
    TOPOLOGY("topology", "org.osid.topology", "org.osid.topology.TopologyManager", "org.osid.topology.TopologyProxyManager", "The Topology Open Service Interface Definition."),

    /** The Tracking Open Service Interface Definition. */
    TRACKING("tracking", "org.osid.tracking", "org.osid.tracking.TrackingManager", "org.osid.tracking.TrackingProxyManager", "The Tracking Open Service Interface Definition."),

    /** The Transaction Open Service Interface Definition. */
    TRANSACTION("transaction", "org.osid.transaction", "org.osid.transaction.TransactionManager", "org.osid.transaction.TransactionProxyManager", "The Transaction Open Service Interface Definition."),

    /** The Transport Open Service Interface Definition. */
    TRANSPORT("transport", "org.osid.transport", "org.osid.transport.TransportManager", "org.osid.transport.TransportProxyManager", "The Transport Open Service Interface Definition."),

    /** The Type Open Service Interface Definition. */
    TYPE("type", "org.osid.type", "org.osid.type.TypeManager", "org.osid.type.TypeProxyManager", "The Type Open Service Interface Definition."),

    /** The Voting Open Service Interface Definition. */
    VOTING("voting", "org.osid.voting", "org.osid.voting.VotingManager", "org.osid.voting.VotingProxyManager", "The Voting Open Service Interface Definition."),

    /** The Workflow Open Service Interface Definition. */
    WORKFLOW("workflow", "org.osid.workflow", "org.osid.workflow.WorkflowManager", "org.osid.workflow.WorkflowProxyManager", "The Workflow Open Service Interface Definition.");


    private final String service;
    private final String osid;
    private final String manager;
    private final String proxyManager;
    private final String description;

    OSID(String service, String osid, String manager, String proxyManager, String description) {
        this.service      = service;
        this.osid         = osid;
        this.manager      = manager;
        this.proxyManager = proxyManager;
        this.description  = description;
    }

    public String getOSIDServiceName() {
        return (this.service);
    }

    public String getOSIDPackageName() {
        return (this.osid);
    }

    public String getManager() {
        return (this.manager);
    }

    public String getProxyManager() {
        return (this.proxyManager);
    }

    public String getDescription() {
        return (this.description);
    }
}
