/**
 * <p>The Open Service Interface Definitions for the org.osid.acknowledgement
 * service.</p>
 * 
 * <p>The Acknowledgement OSID defines and relates credits such as authors or 
 * creators to <code> OsidObjects. </code> </p> 
 * <h4> Credits </h4> 
 * 
 * <p> <code> Credits </code> are relationships between what is being credited 
 * and to what the credit applies. The enttity being credited is represented 
 * by a <code> Resource. </code> This service does not define the entity to 
 * which the credit applies and instead references an OSID <code> Id </code> 
 * external to this service. The <code> Id </code> is a reference to an entity 
 * managed outside this service. </p> 
 * 
 * <p> The external <code> Id </code> reference positions the Acknowledgement 
 * OSID as an auxiliary service that can be orchestrated with other OSIDs to 
 * provide acknowledgements with any <code> OsidObject. </code> Resource is an 
 * abstract interface used for a variety of purposes including people. The 
 * Acknowledgement OSID this has a very abstract feel whose primary focus is 
 * to manage the relationships. </p> 
 * 
 * <p> As with many <code> OsidRelationships, </code> the genus Type can be 
 * used to describe the nature of the relationship, such as a writer or 
 * photographer. The <code> CreditRecord </code> may be used to capture data 
 * related to the relatonship itself. </p> 
 * 
 * <p> <code> OsidRelationships </code> are temporal by including effective 
 * dates. </p> 
 * <h4> Billing Cataloging </h4> 
 * 
 * <p> <code> Credits </code> are mapped to <code> Billings </code> for 
 * organization. <code> Billings </code> can be managed hierarchically to 
 * federate multiple collections of <code> Credits </code> . </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2011 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may modify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.acknowledgement;
