/**
 * <p>The Open Service Interface Definitions for the org.osid.cataloging.rules
 * service.</p>
 * 
 * <p>The Cataloging Rules OSID includes rules services to manage rules 
 * applied to Catalogs. </p> 
 * <h4> CatalogEnabler Rule </h4> 
 * 
 * <p> A <code> CatalogEnabler </code> is an <code> OsidRule </code> that 
 * operates the enabling and disabling of a <code> Catalog </code> within a 
 * federated hierarchy. An active <code> Catalog </code> is one that actively 
 * particpates in the federation resulting in the inclusion of any <code> 
 * OsidObjects </code> mapped to the <code> Catalog </code> and that of any of 
 * its descendants. An inactive Catalog effecively hides the mapped <code> 
 * OsidObjects </code> and that of its descendants from the federation. In 
 * either case, the <code> Catalog </code> itself is visible in the federated 
 * hierarchy. </p> 
 * <h4> Catalog Cataloging </h4> 
 * 
 * <p> <code> CatalogEnablers </code> are also cataloged in <code> Catalogs. 
 * </code> In the Catalog OSID, care must be taken to distinguish between the 
 * <code> CatalogEnablers </code> mapped to a <code> Catalog </code> for the 
 * purpose of cataloging and the <code> CatalogEnablers </code> applied to 
 * Catalog. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2011 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.cataloging.rules;
