/**
 * <p>The Open Service Interface Definitions for the org.osid.commenting
 * service.</p>
 * 
 * <p>The Commenting OSID provides a means of relating user comments and 
 * ratings to OSID Objects. </p> 
 * 
 * <p> The Commenting OSID may be used as an auxiliary service orchestrated 
 * with other OSIDs to either provide administrative comments as well as 
 * create a social network-esque comment and rating service to various <code> 
 * OsidObjects. </code> </p> 
 * <h4> Comments </h4> 
 * 
 * <p> <code> Comments </code> contain text entries logged by date and <code> 
 * Agent. </code> A <code> Comment </code> may also include a rating 
 * represented by a <code> Grade </code> defined in a <code> GradeSystem. 
 * </code> The <code> RatingLookupSession </code> may be used to query 
 * cumulative scores across an object reference or the entire <code> Book. 
 * </code> </p> 
 * 
 * <p> <code> Comments </code> are <code> OsidRelationships </code> between a 
 * commentor and a reference Id. The relationship defines dates for which the 
 * comment and/or rating is effective. </p> 
 * <h4> Commentors </h4> 
 * 
 * <p> An <code> Agent </code> comments on something. As a person is 
 * represented by a <code> Resource </code> in the Resource OSID, the Comments 
 * provide access to both the commenting <code> Agent </code> and the related 
 * <code> Resource </code> to avoid the need of an additional service 
 * orchestration for resolving the <code> Agent. </code> </p> 
 * <h4> Cataloging </h4> 
 * 
 * <p> <code> Comments </code> are cataloged in <code> Books </code> which may 
 * also be grouped hierarchically to federate multiple collections of 
 * comments. </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Commenting OSID includes a Commenting Batch OSID for managing 
 * <code> Comments </code> and <code> Books </code> in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.commenting;
