/**
 * <p>The Open Service Interface Definitions for the org.osid.course.chronicle
 * service.</p>
 * 
 * <p>The Course Chronicle OSID provides services for examining the academic 
 * record. The entries in the academic record provide summary information for 
 * students in programs and courses as well as any credentials, awards, or 
 * standardized assessment scores the student may have received. </p> 
 * 
 * <p> The Course Chronicle OSID provides services for creating and updating 
 * entries. The entries may be provided as read-only in response to data 
 * stored in other OSIDs or updates may be provided to override generated 
 * entries or manually insert new entries. </p> 
 * 
 * <p> The following types of entries are defined that relate to their 
 * respective counterparts. </p> 
 * 
 * <ul>
 *     <li> CourseEntries </li> 
 *     <li> ProgramEntries </li> 
 *     <li> CredentialEntries </li> 
 *     <li> AssessmentEntries </li> 
 *     <li> AwardEntries </li> 
 * </ul>
 * 
 * 
 * <p> Quick access to these entries on a per student basis may be done in the 
 * <code> AcademicRecordSession. </code> </p> 
 * <h4> CourseCatalog Cataloging </h4> 
 * 
 * <p> <code> CourseEntries, </code> <code> ProgramEntries, CredentialEntries, 
 * AssessmentEntries, </code> and <code> AwardEntries </code> can be organized 
 * into federateble <code> OsidCatalogs. </code> </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may modify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.course.chronicle;
