/**
 * <p>The Open Service Interface Definitions for the org.osid.financials.posting
 * service.</p>
 * 
 * <p>The Financials Posting OSID manages accounting transactions. </p> 
 * <h4> Post Entry </h4> 
 * 
 * <p> A <code> PostEntry </code> is a debit or a credit to or from an <code> 
 * Activity </code> and general ledger Account. Post entries are part of a 
 * <code> Post </code> . </p> 
 * <h4> Posts </h4> 
 * 
 * <p> A <code> Post </code> is the entire accounting transaction composed of 
 * <code> PostEntries. </code> The sum of all <code> PostEntries </code> in a 
 * <code> Post </code> should balance in a double entry accounting scheme. 
 * </p> 
 * 
 * <p> A <code> Post </code> is related to a specific <code> FiscalPeriod. 
 * </code> A <code> Post </code> may also be marked as a correction to a 
 * previous <code> Post </code> where the posting date falls outside the 
 * targeted FiscalPeriod. </p> 
 * 
 * <p> The posting is complete when the <code> Post </code> if posted. Before 
 * it is posted, the <code> Post </code> may be updated and assembled wby 
 * creating <code> PostEntries. </code> Typically, once a <code> Post </code> 
 * is submitted it is frozen. </p> 
 * 
 * <p> A Post is transactional in that the posting of all <code> PostEntries 
 * </code> succeeeds or fails. </p> 
 * <h4> Business Cataloging </h4> 
 * 
 * <p> <code> Posts </code> and <code> PostEntries </code> can be organized 
 * into federateble <code> Businesses. </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Financials Posting OSID contains a Financials Posting Batch OSID 
 * for managing <code> Posts </code> and <code> PostEntries </code> in bulk. 
 * </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2012 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may modify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.financials.posting;
