/**
 * <p>The Open Service Interface Definitions for the org.osid.hierarchy
 * service.</p>
 * 
 * <p>The Hierarchy OSID is an auxiliary service providing a means for 
 * accessing and managing hierarchical relationships among OSID <code> Ids. 
 * </code> </p> 
 * 
 * <p> An OSID <code> Id </code> may have onr or more parents or children and 
 * the hierarchy itself represents a directed acyclic graph. The hierarchy 
 * service defines a set of interfaces used among other OSIDs that utilize 
 * hierarchies and can also be used to abstract hierarchical data into a 
 * standalone service. </p> 
 * 
 * <p> Hierarchical queries may be performed using the <code> 
 * HierarchyTraversalSession. </code> A set of methods exist to query parents, 
 * children, ancestors, and decendants. A Node structure may be retrieved to 
 * access a portion of a hierarchy in bulk. The <code> Node </code> provides 
 * methods to get parents and children of the node directly. </p> 
 * 
 * <p> Hierarchies are federateable by combining nodes. There is no hierarchy 
 * service for the hierarchy catalog. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2002,2008 Massachusetts Institute of Technology. </p> 
 * 
 * <p> Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.hierarchy;
