/**
 * <p>The Open Service Interface Definitions for the org.osid.inquiry.rules
 * service.</p>
 * 
 * <p>The Inquiry Rules OSID includes rules services to manage rules and 
 * constraints applied to <code> Inquiries. </code> </p> 
 * <h4> InquiryEnabler Rule </h4> 
 * 
 * <p> An <code> InquiryEnabler </code> is an <code> OsidRule </code> that 
 * operates the enabling and disabling of <code> Inquiries. </code> </p> 
 * <h4> AuditEnabler Rule </h4> 
 * 
 * <p> An <code> AuditEnabler </code> is an <code> OsidRule </code> that 
 * operates the enabling and disabling of an <code> Audit. </code> </p> 
 * <h4> Inquest Cataloging </h4> 
 * 
 * <p> <code> AuditEnablers </code> and <code> InquiryEnablers </code> are 
 * also cataloged in <code> Inquests. </code> </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2013 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * INQUIRY OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.inquiry.rules;
