/**
 * <p>The Open Service Interface Definitions for the org.osid.journaling
 * service.</p>
 * 
 * <p>The Journaling OSID defines an auxiliary service to manage journals and 
 * journal entries for versioining. </p> 
 * <h4> Journal Entries </h4> 
 * 
 * <p> A journal entry represents a change to an object that can be another 
 * OSID. The journal entry contains a time, a source <code> Id </code> and a 
 * version <code> Id. </code> The source <code> Id </code> is the principal 
 * identifier for the journaled object while the version <code> Id </code> can 
 * be used to retrieve a previous version of the object by using its 
 * respective lookup session. </p> 
 * <h4> Journal Cataloging </h4> 
 * 
 * <p> Journal entries can be categorized into <code> Journals, </code> which 
 * may also be organized into hierarchies for the purpose of federating 
 * journal entries. </p> 
 * <h4> Agents & Resources </h4> 
 * 
 * <p> An <code> Agent </code> creates a <code> JournalEntry. </code> The 
 * <code> JournalEntry </code> directly exposes the related <code> Resource 
 * </code> to manage the orchestration with a Resourtce OSID. Multiple <code> 
 * Agents </code> may be acting on behalf of a <code> Resource. </code> </p> 
 * <h4> Orchestration </h4> 
 * 
 * <p> An orchestrated journaling service is one that creates a journaling 
 * entry for each create and update of an <code> OsidObject. </code> The 
 * orchestration can be tricky since there is no means for connecting a <code> 
 * JournalEntry </code> to a specific <code> OsidObject. </code> other than to 
 * arrange the <code> Journals </code> such that each <code> Journal </code> 
 * contains entries for a designated <code> OsidObject </code> interface where 
 * multiple <code> OsidObjects </code> are journaled. </p> 
 * 
 * <p> The Journaling OSID is designed to provide a history of the data 
 * contained within an OSID object, such as the evolution of an <code> Asset 
 * </code> or a <code> Resource. </code> OSIDs tend to offer a complex array 
 * of relationships. To capture a history of all relationships, states, and 
 * cataloging of an <code> OsidObject, </code> an OSID Provider can offer a 
 * rollback of an entire OSID to a designated point in time. </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Journaling OSID contains a Journaling Batch OSID for managing 
 * <code> JournalEntries, </code> <code> Branches, </code> and <code> Journals 
 * </code> in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2009, 2011 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.journaling;
