/**
 * <p>The Open Service Interface Definitions for the org.osid.logging
 * service.</p>
 * 
 * <p>The Logging OSID provides a means to read and wite to logs. A Log 
 * represents a collection of log entries. Each log entry is composed of a 
 * priority <code> Type, </code> timestamp, <code> Agent, </code> the agent's 
 * associated <code> Resource, </code> and a record. </p> 
 * 
 * <p> Logs can be organized into hierarchies for federation. A log that is a 
 * parent of another log makes visible the log entries of its children. </p> 
 * <h4> Example </h4> 
 * 
 * <pre>
 *      
 *      
 *      LoggingSession out = manager.getLoggingSession();
 *      out.log(warningLogEntryPriorityType, "hello world", stringLogEntryContentType);
 *      
 *      LogReadingSession in = manager.getLogReadingSession();
 *      LogEntryList entries = inn.getLogEntries();
 *      while (entries.hasNext()) {
 *          LogEntry entry = entries.getNextLogEntry();
 *          printEntry(entry);
 *      }
 *      
 *              
 *      
 * </pre>
 * 
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2002-2004, 2006-2008 Massachusetts Institute of 
 * Technology. </p> 
 * 
 * <p> Copyright &copy; 2011 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.logging;
