package org.osid.meta.loader.messaging.batch;

import org.osid.meta.Osids;


/**
 *  Loads and stores the org.osid.messaging.batch OSID.
 *
 *  Generated by the Java Meta OSID Binder at Fri Jun 20 12:32:57 EDT 2014
 */

public class Loader {
    private static boolean loaded = false;
    private static boolean loadedMessagingBatchProfile = false;
    private static boolean loadedMessagingBatchManager = false;
    private static boolean loadedMessagingBatchProxyManager = false;
    private static boolean loadedMessageBatchAdminSession = false;
    private static boolean loadedReceiptBatchAdminSession = false;
    private static boolean loadedMailboxBatchAdminSession = false;
    private static boolean loadedMessageBatchForm = false;
    private static boolean loadedMessageBatchFormList = false;
    private static boolean loadedReceiptBatchForm = false;
    private static boolean loadedReceiptBatchFormList = false;
    private static boolean loadedMailboxBatchForm = false;
    private static boolean loadedMailboxBatchFormList = false;

    public static void loadAllInterfaces() {
        if (loaded) {
            return;
        }

        loadMessagingBatchProfile();
        loadMessagingBatchManager();
        loadMessagingBatchProxyManager();
        loadMessageBatchAdminSession();
        loadReceiptBatchAdminSession();
        loadMailboxBatchAdminSession();
        loadMessageBatchForm();
        loadMessageBatchFormList();
        loadReceiptBatchForm();
        loadReceiptBatchFormList();
        loadMailboxBatchForm();
        loadMailboxBatchFormList();
        loaded = true;
        loadedMessagingBatchProfile = true;
        loadedMessagingBatchManager = true;
        loadedMessagingBatchProxyManager = true;
        loadedMessageBatchAdminSession = true;
        loadedReceiptBatchAdminSession = true;
        loadedMailboxBatchAdminSession = true;
        loadedMessageBatchForm = true;
        loadedMessageBatchFormList = true;
        loadedReceiptBatchForm = true;
        loadedReceiptBatchFormList = true;
        loadedMailboxBatchForm = true;
        loadedMailboxBatchFormList = true;

        return;
    }


    public static void loadMessagingBatchProfile() {
        if (loadedMessagingBatchProfile) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.messaging.batch.MessagingBatchProfile");
        osids.getOsid("org.osid.messaging.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsMessageBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsReceiptBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsMailboxBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadMessagingBatchManager() {
        if (loadedMessagingBatchManager) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.messaging.batch.MessagingBatchManager");
        osids.getOsid("org.osid.messaging.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("initialize");
        method.addParameter(new OsidParameter("runtime", "org.osid.OsidRuntimeManager", false));
        method.addError("org.osid.ConfigurationErrorException");
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("rollbackService");
        method.addParameter(new OsidParameter("rollbackTime", "java.util.Date", false, "timestamp"));
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntry", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changeBranch");
        method.addParameter(new OsidParameter("branchId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsMessageBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsReceiptBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsMailboxBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMessageBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MessageBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getMessageBatchAdminSessionForMailbox");
        method.addParameter(new OsidParameter("mailboxId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MessageBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getReceiptBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.messaging.batch.ReceiptBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getReceiptBatchAdminSessionForMailbox");
        method.addParameter(new OsidParameter("mailboxId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.ReceiptBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getMailboxBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MailboxBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadMessagingBatchProxyManager() {
        if (loadedMessagingBatchProxyManager) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.messaging.batch.MessagingBatchProxyManager");
        osids.getOsid("org.osid.messaging.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("initialize");
        method.addParameter(new OsidParameter("runtime", "org.osid.OsidRuntimeManager", false));
        method.addError("org.osid.ConfigurationErrorException");
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("rollbackService");
        method.addParameter(new OsidParameter("rollbackTime", "java.util.Date", false, "timestamp"));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntry", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changeBranch");
        method.addParameter(new OsidParameter("branchId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsMessageBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsReceiptBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsMailboxBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMessageBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MessageBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getMessageBatchAdminSessionForMailbox");
        method.addParameter(new OsidParameter("mailboxId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MessageBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getReceiptBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.ReceiptBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getReceiptBatchAdminSessionForMailbox");
        method.addParameter(new OsidParameter("mailboxId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.ReceiptBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getMailboxBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MailboxBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadMessageBatchAdminSession() {
        if (loadedMessageBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.messaging.batch.MessageBatchAdminSession");
        osids.getOsid("org.osid.messaging.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getMailboxId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMailbox");
        method.setReturn(new OsidReturn("org.osid.messaging.Mailbox", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateMessages");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateMessageWithRecordTypes");
        method.addParameter(new OsidParameter("messageRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMessageFormForCreate");
        method.addParameter(new OsidParameter("messageRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.messaging.MessageForm", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createMessage");
        method.addParameter(new OsidParameter("messageForm", "org.osid.messaging.MessageForm", false));
        method.setReturn(new OsidReturn("org.osid.messaging.Message", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateMessages");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMessageFormForUpdate");
        method.addParameter(new OsidParameter("messageId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.messaging.MessageForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateMessage");
        method.addParameter(new OsidParameter("messageForm", "org.osid.messaging.MessageForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteMessages");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteMessage");
        method.addParameter(new OsidParameter("messageId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageMessageAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasMessage");
        method.addParameter(new OsidParameter("messageId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMessageFormsForCreate");
        method.addParameter(new OsidParameter("number", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("messageRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MessageBatchFormList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createMessages");
        method.addParameter(new OsidParameter("messageForms", "org.osid.messaging.batch.MessageBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMessageFormsForUpdate");
        method.addParameter(new OsidParameter("messageIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MessageBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateMessages");
        method.addParameter(new OsidParameter("messageForms", "org.osid.messaging.batch.MessageBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllMessages");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteMessagesBySender");
        method.addParameter(new OsidParameter("resourceId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteMessagesByDate");
        method.addParameter(new OsidParameter("from", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("to", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasMessages");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadReceiptBatchAdminSession() {
        if (loadedReceiptBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.messaging.batch.ReceiptBatchAdminSession");
        osids.getOsid("org.osid.messaging.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getMailboxId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMailbox");
        method.setReturn(new OsidReturn("org.osid.messaging.Mailbox", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateReceipts");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReceiptFormForUpdate");
        method.addParameter(new OsidParameter("receiptId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.messaging.ReceiptForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateReceipt");
        method.addParameter(new OsidParameter("receiptForm", "org.osid.messaging.ReceiptForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReceiptFormsForUpdate");
        method.addParameter(new OsidParameter("receiptIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.ReceiptBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateReceipts");
        method.addParameter(new OsidParameter("receiptForms", "org.osid.messaging.batch.ReceiptBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadMailboxBatchAdminSession() {
        if (loadedMailboxBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.messaging.batch.MailboxBatchAdminSession");
        osids.getOsid("org.osid.messaging.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("canCreateMailboxes");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateMailboxWithRecordTypes");
        method.addParameter(new OsidParameter("mailboxRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMailboxFormForCreate");
        method.addParameter(new OsidParameter("mailboxRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.messaging.MailboxForm", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createMailbox");
        method.addParameter(new OsidParameter("mailboxForm", "org.osid.messaging.MailboxForm", false));
        method.setReturn(new OsidReturn("org.osid.messaging.Mailbox", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateMailboxes");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMailboxFormForUpdate");
        method.addParameter(new OsidParameter("mailboxId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.messaging.MailboxForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateMailbox");
        method.addParameter(new OsidParameter("mailboxForm", "org.osid.messaging.MailboxForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteMailboxes");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteMailbox");
        method.addParameter(new OsidParameter("mailboxId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageMailboxAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasMailbox");
        method.addParameter(new OsidParameter("mailboxId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMailboxFormsForCreate");
        method.addParameter(new OsidParameter("number", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("mailboxRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MailboxBatchFormList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createMailboxes");
        method.addParameter(new OsidParameter("mailboxForms", "org.osid.messaging.batch.MailboxBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMailboxFormsForUpdate");
        method.addParameter(new OsidParameter("mailboxIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MailboxBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateMailboxes");
        method.addParameter(new OsidParameter("mailboxForms", "org.osid.messaging.batch.MailboxBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllMailboxes");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteMailboxes");
        method.addParameter(new OsidParameter("mailboxIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasMailboxes");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadMessageBatchForm() {
        if (loadedMessageBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.messaging.batch.MessageBatchForm");
        osids.getOsid("org.osid.messaging.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getSubjectLineMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setSubjectLine");
        method.addParameter(new OsidParameter("subject", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearSubjectLine");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getTextMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setText");
        method.addParameter(new OsidParameter("text", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearText");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMessageFormRecord");
        method.addParameter(new OsidParameter("messageRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.messaging.records.MessageFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMessageId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadMessageBatchFormList() {
        if (loadedMessageBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.messaging.batch.MessageBatchFormList");
        osids.getOsid("org.osid.messaging.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextMessageBatchForm");
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MessageBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextMessageBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MessageBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadReceiptBatchForm() {
        if (loadedReceiptBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.messaging.batch.ReceiptBatchForm");
        osids.getOsid("org.osid.messaging.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReceiptFormRecord");
        method.addParameter(new OsidParameter("receiptRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.messaging.records.ReceiptFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReceiptId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadReceiptBatchFormList() {
        if (loadedReceiptBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.messaging.batch.ReceiptBatchFormList");
        osids.getOsid("org.osid.messaging.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextReceiptBatchForm");
        method.setReturn(new OsidReturn("org.osid.messaging.batch.ReceiptBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextReceiptBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.ReceiptBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadMailboxBatchForm() {
        if (loadedMailboxBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.messaging.batch.MailboxBatchForm");
        osids.getOsid("org.osid.messaging.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setProvider");
        method.addParameter(new OsidParameter("providerId", "org.osid.id.Id", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearProvider");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setBranding");
        method.addParameter(new OsidParameter("assetIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearBranding");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicenseMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLicense");
        method.addParameter(new OsidParameter("license", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearLicense");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMailboxFormRecord");
        method.addParameter(new OsidParameter("mailboxRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.messaging.records.MailboxFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getMailboxId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getParentsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setParents");
        method.addParameter(new OsidParameter("parents", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearParents");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadMailboxBatchFormList() {
        if (loadedMailboxBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.messaging.batch.MailboxBatchFormList");
        osids.getOsid("org.osid.messaging.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextMailboxBatchForm");
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MailboxBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextMailboxBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.messaging.batch.MailboxBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }
}
