package org.osid.meta.loader.recipe.batch;

import org.osid.meta.Osids;


/**
 *  Loads and stores the org.osid.recipe.batch OSID.
 *
 *  Generated by the Java Meta OSID Binder at Fri Jun 20 12:33:01 EDT 2014
 */

public class Loader {
    private static boolean loaded = false;
    private static boolean loadedRecipeBatchProfile = false;
    private static boolean loadedRecipeBatchManager = false;
    private static boolean loadedRecipeBatchProxyManager = false;
    private static boolean loadedRecipeBatchAdminSession = false;
    private static boolean loadedDirectionBatchAdminSession = false;
    private static boolean loadedProcedureBatchAdminSession = false;
    private static boolean loadedCookbookBatchAdminSession = false;
    private static boolean loadedRecipeBatchForm = false;
    private static boolean loadedRecipeBatchFormList = false;
    private static boolean loadedDirectionBatchForm = false;
    private static boolean loadedDirectionBatchFormList = false;
    private static boolean loadedIngredientBatchForm = false;
    private static boolean loadedIngredientBatchFormList = false;
    private static boolean loadedProcedureBatchForm = false;
    private static boolean loadedProcedureBatchFormList = false;
    private static boolean loadedCookbookBatchForm = false;
    private static boolean loadedCookbookBatchFormList = false;

    public static void loadAllInterfaces() {
        if (loaded) {
            return;
        }

        loadRecipeBatchProfile();
        loadRecipeBatchManager();
        loadRecipeBatchProxyManager();
        loadRecipeBatchAdminSession();
        loadDirectionBatchAdminSession();
        loadProcedureBatchAdminSession();
        loadCookbookBatchAdminSession();
        loadRecipeBatchForm();
        loadRecipeBatchFormList();
        loadDirectionBatchForm();
        loadDirectionBatchFormList();
        loadIngredientBatchForm();
        loadIngredientBatchFormList();
        loadProcedureBatchForm();
        loadProcedureBatchFormList();
        loadCookbookBatchForm();
        loadCookbookBatchFormList();
        loaded = true;
        loadedRecipeBatchProfile = true;
        loadedRecipeBatchManager = true;
        loadedRecipeBatchProxyManager = true;
        loadedRecipeBatchAdminSession = true;
        loadedDirectionBatchAdminSession = true;
        loadedProcedureBatchAdminSession = true;
        loadedCookbookBatchAdminSession = true;
        loadedRecipeBatchForm = true;
        loadedRecipeBatchFormList = true;
        loadedDirectionBatchForm = true;
        loadedDirectionBatchFormList = true;
        loadedIngredientBatchForm = true;
        loadedIngredientBatchFormList = true;
        loadedProcedureBatchForm = true;
        loadedProcedureBatchFormList = true;
        loadedCookbookBatchForm = true;
        loadedCookbookBatchFormList = true;

        return;
    }


    public static void loadRecipeBatchProfile() {
        if (loadedRecipeBatchProfile) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.RecipeBatchProfile");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsRecipeBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsDirectionBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProcedureBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsCookbookBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRecipeBatchManager() {
        if (loadedRecipeBatchManager) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.RecipeBatchManager");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("initialize");
        method.addParameter(new OsidParameter("runtime", "org.osid.OsidRuntimeManager", false));
        method.addError("org.osid.ConfigurationErrorException");
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("rollbackService");
        method.addParameter(new OsidParameter("rollbackTime", "java.util.Date", false, "timestamp"));
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntry", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changeBranch");
        method.addParameter(new OsidParameter("branchId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsRecipeBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsDirectionBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProcedureBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsCookbookBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecipeBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.recipe.batch.RecipeBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getRecipeBatchAdminSessionForCookbook");
        method.addParameter(new OsidParameter("cookbookId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.RecipeBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getDirectionBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.recipe.batch.DirectionBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getDirectionBatchAdminSessionForCookbook");
        method.addParameter(new OsidParameter("cookbookId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.DirectionBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getProcedureBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.recipe.batch.ProcedureBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getProcedureBatchAdminSessionForCookbook");
        method.addParameter(new OsidParameter("cookbookId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.ProcedureBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCookbookBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.recipe.batch.CookbookBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRecipeBatchProxyManager() {
        if (loadedRecipeBatchProxyManager) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.RecipeBatchProxyManager");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("initialize");
        method.addParameter(new OsidParameter("runtime", "org.osid.OsidRuntimeManager", false));
        method.addError("org.osid.ConfigurationErrorException");
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("rollbackService");
        method.addParameter(new OsidParameter("rollbackTime", "java.util.Date", false, "timestamp"));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntry", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changeBranch");
        method.addParameter(new OsidParameter("branchId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsRecipeBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsDirectionBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProcedureBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsCookbookBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecipeBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.RecipeBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getRecipeBatchAdminSessionForCookbook");
        method.addParameter(new OsidParameter("cookbookId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.RecipeBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getDirectionBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.DirectionBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getDirectionBatchAdminSessionForCookbook");
        method.addParameter(new OsidParameter("cookbookId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.DirectionBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getProcedureBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.ProcedureBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getProcedureBatchAdminSessionForCookbook");
        method.addParameter(new OsidParameter("cookbookId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.ProcedureBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCookbookBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.CookbookBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRecipeBatchAdminSession() {
        if (loadedRecipeBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.RecipeBatchAdminSession");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCookbookId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCookbook");
        method.setReturn(new OsidReturn("org.osid.recipe.Cookbook", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateRecipes");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateRecipeWithRecordTypes");
        method.addParameter(new OsidParameter("recipeRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecipeFormForCreate");
        method.addParameter(new OsidParameter("recipeRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.recipe.RecipeForm", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createRecipe");
        method.addParameter(new OsidParameter("recipeForm", "org.osid.recipe.RecipeForm", false));
        method.setReturn(new OsidReturn("org.osid.recipe.Recipe", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateRecipes");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecipeFormForUpdate");
        method.addParameter(new OsidParameter("recipeId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.recipe.RecipeForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateRecipe");
        method.addParameter(new OsidParameter("recipeForm", "org.osid.recipe.RecipeForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteRecipes");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteRecipe");
        method.addParameter(new OsidParameter("recipeId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageRecipeAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasRecipe");
        method.addParameter(new OsidParameter("recipeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecipeFormsForCreate");
        method.addParameter(new OsidParameter("number", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("recipeRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.RecipeBatchFormList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createRecipes");
        method.addParameter(new OsidParameter("recipeForms", "org.osid.recipe.batch.RecipeBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecipeFormsForUpdate");
        method.addParameter(new OsidParameter("recipeIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.RecipeBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateRecipes");
        method.addParameter(new OsidParameter("recipeForms", "org.osid.recipe.batch.RecipeBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllRecipes");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteRecipes");
        method.addParameter(new OsidParameter("recipeIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasRecipes");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadDirectionBatchAdminSession() {
        if (loadedDirectionBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.DirectionBatchAdminSession");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCookbookId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCookbook");
        method.setReturn(new OsidReturn("org.osid.recipe.Cookbook", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateDirections");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateDirectionWithRecordTypes");
        method.addParameter(new OsidParameter("directionRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDirectionFormForCreate");
        method.addParameter(new OsidParameter("recipeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("directionRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.recipe.DirectionForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createDirection");
        method.addParameter(new OsidParameter("directionForm", "org.osid.recipe.DirectionForm", false));
        method.setReturn(new OsidReturn("org.osid.recipe.Direction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateDirections");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDirectionFormForUpdate");
        method.addParameter(new OsidParameter("directionId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.recipe.DirectionForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateDirection");
        method.addParameter(new OsidParameter("directionForm", "org.osid.recipe.DirectionForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteDirections");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteDirection");
        method.addParameter(new OsidParameter("directionId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageDirectionAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasDirection");
        method.addParameter(new OsidParameter("directionId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageIngredients");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateIngredientWithRecordTypes");
        method.addParameter(new OsidParameter("ingredientRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getIngredientFormForCreate");
        method.addParameter(new OsidParameter("directionId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("ingredientRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.recipe.IngredientForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createIngredient");
        method.addParameter(new OsidParameter("ingredientForm", "org.osid.recipe.IngredientForm", false));
        method.setReturn(new OsidReturn("org.osid.recipe.Ingredient", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getIngredientFormForUpdate");
        method.addParameter(new OsidParameter("ingredientId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.recipe.IngredientForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateIngredient");
        method.addParameter(new OsidParameter("ingredientForm", "org.osid.recipe.IngredientForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteIngredient");
        method.addParameter(new OsidParameter("ingredientId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canSequenceDirections");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("moveDirectionAhead");
        method.addParameter(new OsidParameter("directionId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("recipeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("referenceId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("moveDirectionBehind");
        method.addParameter(new OsidParameter("directionId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("recipeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("referenceId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderDirections");
        method.addParameter(new OsidParameter("directionIds", "org.osid.id.Id[]", true));
        method.addParameter(new OsidParameter("recipeId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDirectionFormsForCreate");
        method.addParameter(new OsidParameter("recipieIds", "org.osid.id.IdList", false));
        method.addParameter(new OsidParameter("directionRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.DirectionBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createDirections");
        method.addParameter(new OsidParameter("directionForms", "org.osid.recipe.batch.DirectionBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDirectionFormsForUpdate");
        method.addParameter(new OsidParameter("directionIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.DirectionBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateDirections");
        method.addParameter(new OsidParameter("directionForms", "org.osid.recipe.batch.DirectionBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllDirections");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteDirections");
        method.addParameter(new OsidParameter("directionIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteDirectionsForRecipe");
        method.addParameter(new OsidParameter("recipeId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasDirections");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getIngredientFormsForCreate");
        method.addParameter(new OsidParameter("directionIds", "org.osid.id.IdList", false));
        method.addParameter(new OsidParameter("ingredientRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.IngredientBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createIngredients");
        method.addParameter(new OsidParameter("ingredientForms", "org.osid.recipe.batch.IngredientBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getIngredientFormsForUpdate");
        method.addParameter(new OsidParameter("ingredientIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.IngredientBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateIngredients");
        method.addParameter(new OsidParameter("ingredientForms", "org.osid.recipe.batch.IngredientBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllIngredients");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteIngredients");
        method.addParameter(new OsidParameter("ingredientsIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteIngredientsForDirection");
        method.addParameter(new OsidParameter("directionId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadProcedureBatchAdminSession() {
        if (loadedProcedureBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.ProcedureBatchAdminSession");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getCookbookId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCookbook");
        method.setReturn(new OsidReturn("org.osid.recipe.Cookbook", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateProcedures");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateProcedureWithRecordTypes");
        method.addParameter(new OsidParameter("procedureRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProcedureFormForCreate");
        method.addParameter(new OsidParameter("procedureRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.recipe.ProcedureForm", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createProcedure");
        method.addParameter(new OsidParameter("procedureForm", "org.osid.recipe.ProcedureForm", false));
        method.setReturn(new OsidReturn("org.osid.recipe.Procedure", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateProcedures");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateProcedure");
        method.addParameter(new OsidParameter("procedureId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProcedureFormForUpdate");
        method.addParameter(new OsidParameter("procedureId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.recipe.ProcedureForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateProcedure");
        method.addParameter(new OsidParameter("procedureForm", "org.osid.recipe.ProcedureForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteProcedures");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteProcedure");
        method.addParameter(new OsidParameter("procedureId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteProcedure");
        method.addParameter(new OsidParameter("procedureId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteProcedures");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageProcedureAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasProcedure");
        method.addParameter(new OsidParameter("procedureId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProcedureFormsForCreate");
        method.addParameter(new OsidParameter("number", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("procedureRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.ProcedureBatchFormList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createProcedures");
        method.addParameter(new OsidParameter("procedureForms", "org.osid.recipe.batch.ProcedureBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProcedureFormsForUpdate");
        method.addParameter(new OsidParameter("procedureIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.ProcedureBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateProcedures");
        method.addParameter(new OsidParameter("procedureForms", "org.osid.recipe.batch.ProcedureBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllProcedures");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteProcedures");
        method.addParameter(new OsidParameter("procedureIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasProcedures");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadCookbookBatchAdminSession() {
        if (loadedCookbookBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.CookbookBatchAdminSession");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("canCreateCookbooks");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateCookbookWithRecordTypes");
        method.addParameter(new OsidParameter("cookbookRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCookbookFormForCreate");
        method.addParameter(new OsidParameter("cookbookRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.recipe.CookbookForm", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createCookbook");
        method.addParameter(new OsidParameter("cookbookForm", "org.osid.recipe.CookbookForm", false));
        method.setReturn(new OsidReturn("org.osid.recipe.Cookbook", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateCookbooks");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCookbookFormForUpdate");
        method.addParameter(new OsidParameter("cookbookId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.recipe.CookbookForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateCookbook");
        method.addParameter(new OsidParameter("cookbookForm", "org.osid.recipe.CookbookForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteCookbooks");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteCookbook");
        method.addParameter(new OsidParameter("cookbookId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageCookbookAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasCookbook");
        method.addParameter(new OsidParameter("cookbookId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCookbookFormsForCreate");
        method.addParameter(new OsidParameter("number", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("cookbookRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.CookbookBatchFormList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createAcademies");
        method.addParameter(new OsidParameter("cookbookForms", "org.osid.recipe.batch.CookbookBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCookbookFormsForUpdate");
        method.addParameter(new OsidParameter("cookbookIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.CookbookBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateAcademies");
        method.addParameter(new OsidParameter("cookbookForms", "org.osid.recipe.batch.CookbookBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllAcademies");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAcademies");
        method.addParameter(new OsidParameter("cookbookIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasAcademies");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRecipeBatchForm() {
        if (loadedRecipeBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.RecipeBatchForm");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setProvider");
        method.addParameter(new OsidParameter("providerId", "org.osid.id.Id", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearProvider");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setBranding");
        method.addParameter(new OsidParameter("assetIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearBranding");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicenseMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLicense");
        method.addParameter(new OsidParameter("license", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearLicense");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getTotalEstimatedDurationMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setTotalEstimatedDuration");
        method.addParameter(new OsidParameter("duration", "org.osid.calendaring.Duration", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearTotalEstimatedDuration");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAssetsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setAssets");
        method.addParameter(new OsidParameter("assetIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearAssets");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecipeFormRecord");
        method.addParameter(new OsidParameter("recipeRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.recipe.records.RecipeFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecipeId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRecipeBatchFormList() {
        if (loadedRecipeBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.RecipeBatchFormList");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextRecipeBatchForm");
        method.setReturn(new OsidReturn("org.osid.recipe.batch.RecipeBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextRecipeBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.RecipeBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadDirectionBatchForm() {
        if (loadedDirectionBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.DirectionBatchForm");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProceduresMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setProcedures");
        method.addParameter(new OsidParameter("procedureIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearProcedures");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEstimatedDurationMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setEstimatedDuration");
        method.addParameter(new OsidParameter("duration", "org.osid.calendaring.Duration", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEstimatedDuration");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAssetsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setAssets");
        method.addParameter(new OsidParameter("assetIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearAssets");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDirectionFormRecord");
        method.addParameter(new OsidParameter("directionRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.recipe.records.DirectionFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecipeId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDirectionId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadDirectionBatchFormList() {
        if (loadedDirectionBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.DirectionBatchFormList");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextDirectionBatchForm");
        method.setReturn(new OsidReturn("org.osid.recipe.batch.DirectionBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextDirectionBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.DirectionBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadIngredientBatchForm() {
        if (loadedIngredientBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.IngredientBatchForm");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getQuantityMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setQuantity");
        method.addParameter(new OsidParameter("quantity", "long", false, "cardinal"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearQuantity");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getUnitTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setUnitType");
        method.addParameter(new OsidParameter("unitType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearUnitType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStockMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setStock");
        method.addParameter(new OsidParameter("stockId", "org.osid.id.Id", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStock");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getIngredientFormRecord");
        method.addParameter(new OsidParameter("ingredientRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.recipe.records.IngredientFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDirectionId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getIngredientId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadIngredientBatchFormList() {
        if (loadedIngredientBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.IngredientBatchFormList");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextIngredientBatchForm");
        method.setReturn(new OsidReturn("org.osid.recipe.batch.IngredientBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextIngredientBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.IngredientBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadProcedureBatchForm() {
        if (loadedProcedureBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.ProcedureBatchForm");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProcedureFormRecord");
        method.addParameter(new OsidParameter("procedureRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.recipe.records.ProcedureFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProcedureId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadProcedureBatchFormList() {
        if (loadedProcedureBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.ProcedureBatchFormList");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextProcedureBatchForm");
        method.setReturn(new OsidReturn("org.osid.recipe.batch.ProcedureBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextProcedureBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.ProcedureBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadCookbookBatchForm() {
        if (loadedCookbookBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.CookbookBatchForm");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setProvider");
        method.addParameter(new OsidParameter("providerId", "org.osid.id.Id", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearProvider");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setBranding");
        method.addParameter(new OsidParameter("assetIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearBranding");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicenseMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLicense");
        method.addParameter(new OsidParameter("license", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearLicense");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCookbookFormRecord");
        method.addParameter(new OsidParameter("cookbookRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.recipe.records.CookbookFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCookbookId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getParentsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setParents");
        method.addParameter(new OsidParameter("parents", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearParents");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadCookbookBatchFormList() {
        if (loadedCookbookBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.recipe.batch.CookbookBatchFormList");
        osids.getOsid("org.osid.recipe.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextCookbookBatchForm");
        method.setReturn(new OsidReturn("org.osid.recipe.batch.CookbookBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextCookbookBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.recipe.batch.CookbookBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }
}
