package org.osid.meta.loader.relationship.batch;

import org.osid.meta.Osids;


/**
 *  Loads and stores the org.osid.relationship.batch OSID.
 *
 *  Generated by the Java Meta OSID Binder at Fri Jun 20 12:33:02 EDT 2014
 */

public class Loader {
    private static boolean loaded = false;
    private static boolean loadedRelationshipBatchProfile = false;
    private static boolean loadedRelationshipBatchManager = false;
    private static boolean loadedRelationshipBatchProxyManager = false;
    private static boolean loadedRelationshipBatchAdminSession = false;
    private static boolean loadedFamilyBatchAdminSession = false;
    private static boolean loadedRelationshipPeer = false;
    private static boolean loadedRelationshipPeerList = false;
    private static boolean loadedRelationshipBatchForm = false;
    private static boolean loadedRelationshipBatchFormList = false;
    private static boolean loadedFamilyBatchForm = false;
    private static boolean loadedFamilyBatchFormList = false;

    public static void loadAllInterfaces() {
        if (loaded) {
            return;
        }

        loadRelationshipBatchProfile();
        loadRelationshipBatchManager();
        loadRelationshipBatchProxyManager();
        loadRelationshipBatchAdminSession();
        loadFamilyBatchAdminSession();
        loadRelationshipPeer();
        loadRelationshipPeerList();
        loadRelationshipBatchForm();
        loadRelationshipBatchFormList();
        loadFamilyBatchForm();
        loadFamilyBatchFormList();
        loaded = true;
        loadedRelationshipBatchProfile = true;
        loadedRelationshipBatchManager = true;
        loadedRelationshipBatchProxyManager = true;
        loadedRelationshipBatchAdminSession = true;
        loadedFamilyBatchAdminSession = true;
        loadedRelationshipPeer = true;
        loadedRelationshipPeerList = true;
        loadedRelationshipBatchForm = true;
        loadedRelationshipBatchFormList = true;
        loadedFamilyBatchForm = true;
        loadedFamilyBatchFormList = true;

        return;
    }


    public static void loadRelationshipBatchProfile() {
        if (loadedRelationshipBatchProfile) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.relationship.batch.RelationshipBatchProfile");
        osids.getOsid("org.osid.relationship.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsRelationshipBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsFamilyBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRelationshipBatchManager() {
        if (loadedRelationshipBatchManager) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.relationship.batch.RelationshipBatchManager");
        osids.getOsid("org.osid.relationship.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("initialize");
        method.addParameter(new OsidParameter("runtime", "org.osid.OsidRuntimeManager", false));
        method.addError("org.osid.ConfigurationErrorException");
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("rollbackService");
        method.addParameter(new OsidParameter("rollbackTime", "java.util.Date", false, "timestamp"));
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntry", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changeBranch");
        method.addParameter(new OsidParameter("branchId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsRelationshipBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsFamilyBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.relationship.batch.RelationshipBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipBatchAdminSessionForFamily");
        method.addParameter(new OsidParameter("familyId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.relationship.batch.RelationshipBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getFamilyBatchAdminSession");
        method.setReturn(new OsidReturn("org.osid.relationship.batch.FamilyBatchAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRelationshipBatchProxyManager() {
        if (loadedRelationshipBatchProxyManager) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.relationship.batch.RelationshipBatchProxyManager");
        osids.getOsid("org.osid.relationship.batch").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("initialize");
        method.addParameter(new OsidParameter("runtime", "org.osid.OsidRuntimeManager", false));
        method.addError("org.osid.ConfigurationErrorException");
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("rollbackService");
        method.addParameter(new OsidParameter("rollbackTime", "java.util.Date", false, "timestamp"));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntry", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changeBranch");
        method.addParameter(new OsidParameter("branchId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsRelationshipBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsFamilyBatchAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.relationship.batch.RelationshipBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipBatchAdminSessionForFamily");
        method.addParameter(new OsidParameter("familyId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.relationship.batch.RelationshipBatchAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getFamilyBatchAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.relationship.batch.FamilyBatchAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRelationshipBatchAdminSession() {
        if (loadedRelationshipBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.relationship.batch.RelationshipBatchAdminSession");
        osids.getOsid("org.osid.relationship.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getFamilyId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFamily");
        method.setReturn(new OsidReturn("org.osid.relationship.Family", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateRelationships");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateRelationshipWithRecordTypes");
        method.addParameter(new OsidParameter("relationshipRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipFormForCreate");
        method.addParameter(new OsidParameter("sourceId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("destinationId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("relationshipRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.relationship.RelationshipForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createRelationship");
        method.addParameter(new OsidParameter("relationshipForm", "org.osid.relationship.RelationshipForm", false));
        method.setReturn(new OsidReturn("org.osid.relationship.Relationship", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateRelationships");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipFormForUpdate");
        method.addParameter(new OsidParameter("relationshipId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.relationship.RelationshipForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateRelationship");
        method.addParameter(new OsidParameter("relationshipForm", "org.osid.relationship.RelationshipForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteRelationships");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteRelationship");
        method.addParameter(new OsidParameter("relationshipId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageRelationshipAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasRelationship");
        method.addParameter(new OsidParameter("relationshipId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipFormsForCreate");
        method.addParameter(new OsidParameter("peers", "org.osid.relationship.batch.RelationshipPeerList", false));
        method.addParameter(new OsidParameter("relationshipRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.relationship.batch.RelationshipBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createRelationships");
        method.addParameter(new OsidParameter("relationshipForms", "org.osid.relationship.batch.RelationshipBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipFormsForUpdate");
        method.addParameter(new OsidParameter("relationshipIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.relationship.batch.RelationshipBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateRelationships");
        method.addParameter(new OsidParameter("relationshipForms", "org.osid.relationship.batch.RelationshipBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllRelationships");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteRelationships");
        method.addParameter(new OsidParameter("relationshipIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteRelationshipsForSourceId");
        method.addParameter(new OsidParameter("sourceId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteRelationshipsForDestinationId");
        method.addParameter(new OsidParameter("destinationId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteIneffectiveRelationshipsByDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasRelationships");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadFamilyBatchAdminSession() {
        if (loadedFamilyBatchAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.relationship.batch.FamilyBatchAdminSession");
        osids.getOsid("org.osid.relationship.batch").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("canCreateFamilies");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreateFamilyWithRecordTypes");
        method.addParameter(new OsidParameter("familyRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFamilyFormForCreate");
        method.addParameter(new OsidParameter("familyRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.relationship.FamilyForm", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createFamily");
        method.addParameter(new OsidParameter("familyForm", "org.osid.relationship.FamilyForm", false));
        method.setReturn(new OsidReturn("org.osid.relationship.Family", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdateFamilies");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFamilyFormForUpdate");
        method.addParameter(new OsidParameter("familyId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.relationship.FamilyForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateFamily");
        method.addParameter(new OsidParameter("familyForm", "org.osid.relationship.FamilyForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeleteFamilies");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteFamily");
        method.addParameter(new OsidParameter("familyId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageFamilyAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasFamily");
        method.addParameter(new OsidParameter("familyId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFamilyFormsForCreate");
        method.addParameter(new OsidParameter("number", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("familyRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.relationship.batch.FamilyBatchFormList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createFamilies");
        method.addParameter(new OsidParameter("familyForms", "org.osid.relationship.batch.FamilyBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.CreateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFamilyFormsForUpdate");
        method.addParameter(new OsidParameter("familyIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.relationship.batch.FamilyBatchFormList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updateFamilies");
        method.addParameter(new OsidParameter("familyForms", "org.osid.relationship.batch.FamilyBatchFormList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.UpdateResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteAllFamilies");
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deleteFamilies");
        method.addParameter(new OsidParameter("familyIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.DeleteResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasFamilies");
        method.addParameter(new OsidParameter("aliasRequests", "org.osid.transaction.batch.AliasRequestList", false));
        method.setReturn(new OsidReturn("org.osid.transaction.batch.AliasResponseList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRelationshipPeer() {
        if (loadedRelationshipPeer) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.relationship.batch.RelationshipPeer");
        osids.getOsid("org.osid.relationship.batch").addInterface(iface);
        method = new OsidMethod("getSourceId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDestinationId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRelationshipPeerList() {
        if (loadedRelationshipPeerList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.relationship.batch.RelationshipPeerList");
        osids.getOsid("org.osid.relationship.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextRelationshipPeer");
        method.setReturn(new OsidReturn("org.osid.relationship.batch.RelationshipPeer", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextRelationshipPeers");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.relationship.batch.RelationshipPeer[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRelationshipBatchForm() {
        if (loadedRelationshipBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.relationship.batch.RelationshipBatchForm");
        osids.getOsid("org.osid.relationship.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setStartDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStartDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setEndDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEndDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipFormRecord");
        method.addParameter(new OsidParameter("relationshipRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.relationship.records.RelationshipFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getSourceNodeId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDestinationNodeId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadRelationshipBatchFormList() {
        if (loadedRelationshipBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.relationship.batch.RelationshipBatchFormList");
        osids.getOsid("org.osid.relationship.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextRelationshipBatchForm");
        method.setReturn(new OsidReturn("org.osid.relationship.batch.RelationshipBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextRelationshipBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.relationship.batch.RelationshipBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadFamilyBatchForm() {
        if (loadedFamilyBatchForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.relationship.batch.FamilyBatchForm");
        osids.getOsid("org.osid.relationship.batch").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setProvider");
        method.addParameter(new OsidParameter("providerId", "org.osid.id.Id", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearProvider");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setBranding");
        method.addParameter(new OsidParameter("assetIds", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearBranding");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicenseMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLicense");
        method.addParameter(new OsidParameter("license", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearLicense");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFamilyFormRecord");
        method.addParameter(new OsidParameter("familyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.relationship.records.FamilyFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFamilyId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getParentsMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setParents");
        method.addParameter(new OsidParameter("parents", "org.osid.id.Id[]", true));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearParents");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadFamilyBatchFormList() {
        if (loadedFamilyBatchFormList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.relationship.batch.FamilyBatchFormList");
        osids.getOsid("org.osid.relationship.batch").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextFamilyBatchForm");
        method.setReturn(new OsidReturn("org.osid.relationship.batch.FamilyBatchForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextFamilyBatchForms");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.relationship.batch.FamilyBatchForm[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }
}
