/**
 * <p>The Open Service Interface Definitions for the org.osid.ontology
 * service.</p>
 * 
 * <p>The Ontology OSID is an auxiliary service used to define subject matter 
 * that can be related to <code> OsidObjects. </code> Ontologies are an 
 * alternative to tagging where structure, restricted vocabulary, or 
 * localization of topic names are desired. </p> 
 * <h4> Subjects </h4> 
 * 
 * <p> <code> Subjects </code> are used to represent a topic and can be 
 * organized in a hierarchy to form an ontology. </p> 
 * <h4> Relevancies </h4> 
 * 
 * <p> <code> Subjects </code> are related to OSID <code> Ids </code> with a 
 * <code> Relevancy. </code> A <code> Relevancy </code> is an <code> 
 * OsidRelationship. </code> </p> 
 * <h4> Ontology Cataloging </h4> 
 * 
 * <p> <code> Subjects </code> and <code> Relevancies </code> are organized 
 * into <code> Ontology </code> catalogs. </p> 
 * 
 * <p> An external <code> Id </code> may be mapped to an <code> Ontology. 
 * </code> This mapping allows <code> OsidCatalogs </code> to relate to a 
 * specific and sharable <code> Ontology </code> to constrain a set of <code> 
 * Subjects </code> that may be relevant to a collection of external <code> 
 * OsidObjects. </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Ontology OSID includes a rules subpackage for managing rules to 
 * enable subject relevancies and an Ontology Batch OSID for managing <code> 
 * Subjects, </code> <code> Relevancies, </code> and <code> Ontologies </code> 
 * in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may nodify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.ontology;
