/**
 * <p>The Open Service Interface Definitions for the org.osid.room.squatting
 * service.</p>
 * 
 * <p>The Room Squatting OSID provides a service for manage space owners, 
 * tenants, and squatters. </p> 
 * <h4> Leases </h4> 
 * 
 * <p> A <code> Lease </code> is an <code> OsidRelationship </code> between a 
 * <code> Room </code> and a "tenant." Although the name implies rentership, 
 * this relationship can be used for a variety of types including office 
 * assignments, space allocation, ownership, and, of course, squatters. </p> 
 * <h4> Deeds </h4> 
 * 
 * <p> A <code> Deed </code> is an OsidRelationship between a Building and an 
 * "owner." Although the name implies ownership, this relationship can be used 
 * for a variety of types including space allocation. </p> 
 * <h4> Campus Cataloging </h4> 
 * 
 * <p> <code> Leases </code> and <code> Deeds </code> may be organized into 
 * federateable <code> OsidCatalogs </code> of <code> Campuses. </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Room Squatting OSID includes a Room Batch Squatting OSID for 
 * managing space relationships in bulk. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2011 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may modify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.room.squatting;
