/**
 * <p>The Open Service Interface Definitions for the org.osid.subscription
 * service.</p>
 * 
 * <p>The Subscription OSID provides a means for subscribing to 
 * communications. Subscribers are represented by <code> Resources. </code> A 
 * Subscription service implicitly uses the Contact OSID for accessing <code> 
 * Addresses </code> for a <code> Resource </code> subscriber. </p> 
 * <h4> Dispatches </h4> 
 * 
 * <p> A <code> Dispatch </code> represents something to which can be 
 * subscribed. A <code> Dispatch </code> may restrict the <code> Address 
 * </code> <code> Types </code> usable by the <code> Resource </code> 
 * subscriber in a <code> Subscription. </code> </p> 
 * <h4> Subscriptions </h4> 
 * 
 * <p> A <code> Subscription </code> is an <code> OsidRelationship </code> 
 * between a <code> Resource </code> and a <code> Dispatch. </code> A <code> 
 * Subscription </code> is effective in a period of time of governed by an 
 * external set of <code> Rules </code> . </p> 
 * <h4> Publisher Cataloging </h4> 
 * 
 * <p> <code> Dispatches </code> and <code> Subscriptions </code> may be 
 * organized into federateable <code> OsidCatalogs </code> of <code> 
 * Publishers. </code> </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Subscription OSID includes a Subscription Rules OSID for managing 
 * effectiveness and subscription constraints on a <code> Dispatch </code> . 
 * </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may modify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.subscription;
