/**
 * <p>The Open Service Interface Definitions for the org.osid.voting
 * service.</p>
 * 
 * <p>The Voting OSID defines a means of holding elections. </p> 
 * <h4> Ballots </h4> 
 * 
 * <p> <code> Ballots </code> are the central <code> OsidGovernator </code> 
 * for the Voting OSID. <code> Ballots </code> are the focal point for a set 
 * of rules that govern the operation of an election. <code> Ballots </code> 
 * are also <code> Temporal </code> where voting occurs within a fixed period 
 * of time. The Voting OSID makes available <code> Ballots </code> which are 
 * active (open for voting), <code> Ballots </code> of past elections, and 
 * <code> Ballots </code> representing scheduled elections in the future. </p> 
 * <h4> Races </h4> 
 * 
 * <p> <code> Ballots </code> are composed of <code> Races. </code> A <code> 
 * Race </code> aggregates a set of <code> Candidates. </code> <code> Races 
 * </code> are constrained to a single <code> Ballot </code> but are also 
 * <code> OsidGovernators </code> to encapsulate the rules governing a 
 * specific race. </p> 
 * <h4> Candidates </h4> 
 * 
 * <p> A <code> Candidate </code> is something to vote for in a <code> Race 
 * </code> on a <code> Ballot. </code> A <code> Candidate </code> is an <code> 
 * OsidRelationship </code> between a <code> Resource </code> and a Race. </p> 
 * <h4> Votes </h4> 
 * 
 * <p> A <code> Vote </code> is cast by a voter for a <code> Candidate. 
 * </code> A <code> Vote </code> is an <code> OsidRelationship </code> between 
 * the voter and a <code> Candidate </code> . Some <code> Ballots </code> may 
 * permit multiple votes to be cast for a <code> Candidate. </code> A <code> 
 * VoterAllocation </code> manages these limits. </p> 
 * <h4> Polls Cataloging </h4> 
 * 
 * <p> <code> Ballots, </code> <code> Races, </code> <code> Candidates, 
 * </code> and <code> Votes </code> may be organized into federateable <code> 
 * Poll </code> catalogs. </p> 
 * <h4> Sub Packages </h4> 
 * 
 * <p> The Voting OSID includes a Voting Rules OSID for managing the 
 * constraints and processing of <code> Ballots </code> and <code> Races 
 * </code> in an election. It also contains a Voting Batch OSID for bulk 
 * administration. </p>
 * 
 * <br/><hr/><br/>
 * 
 * <p>Copyright &copy; 2010 Ingenescus. All Rights Reserved. </p>
 * 
 * <p>This Work is being provided by the copyright holder(s) subject to the 
 * following license. By obtaining, using and/or copying this Work, you agree 
 * that you have read, understand, and will comply with the following terms 
 * and conditions. </p> 
 * 
 * <p> Permission to use, copy and distribute unmodified versions of this 
 * Work, for any purpose, without fee or royalty is hereby granted, provided 
 * that you include the above copyright notices and the terms of this license 
 * on ALL copies of the Work or portions thereof. </p> 
 * 
 * <p> You may modify or create Derivatives of this Work only for your 
 * internal purposes. You shall not distribute or transfer any such Derivative 
 * of this Work to any location or to any third party. For the purposes of 
 * this license, "Derivative" shall mean any derivative of the Work as defined 
 * in the United States Copyright Act of 1976, such as a translation or 
 * modification. </p> 
 * 
 * <p> This Work and the information contained herein is provided on an "AS 
 * IS" basis WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
 * CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS IN THE WORK. </p> 
 * 
 * <p> The export of software employing encryption technology may require a 
 * specific license from the United States Government. It is the 
 * responsibility of any person or organization contemplating export to obtain 
 * such a license before exporting this Work. </p>
 */

package org.osid.voting;
