package org.osid.meta.loader.topology.path;

import org.osid.meta.Osids;


/**
 *  Loads and stores the org.osid.topology.path OSID.
 *
 *  Generated by the Java Meta OSID Binder at Fri Jun 20 12:33:05 EDT 2014
 */

public class Loader {
    private static boolean loaded = false;
    private static boolean loadedTopologyPathProfile = false;
    private static boolean loadedTopologyPathManager = false;
    private static boolean loadedTopologyPathProxyManager = false;
    private static boolean loadedPathLookupSession = false;
    private static boolean loadedPathQuerySession = false;
    private static boolean loadedPathSearchSession = false;
    private static boolean loadedPathAdminSession = false;
    private static boolean loadedPathNotificationSession = false;
    private static boolean loadedPathGraphSession = false;
    private static boolean loadedPathGraphAssignmentSession = false;
    private static boolean loadedPathSmartGraphSession = false;
    private static boolean loadedPath = false;
    private static boolean loadedPathRecord = false;
    private static boolean loadedPathQuery = false;
    private static boolean loadedPathQueryRecord = false;
    private static boolean loadedPathQueryInspector = false;
    private static boolean loadedPathQueryInspectorRecord = false;
    private static boolean loadedPathForm = false;
    private static boolean loadedPathFormRecord = false;
    private static boolean loadedPathSearchOrder = false;
    private static boolean loadedPathSearchOrderRecord = false;
    private static boolean loadedPathSearch = false;
    private static boolean loadedPathSearchRecord = false;
    private static boolean loadedPathSearchResults = false;
    private static boolean loadedPathSearchResultsRecord = false;
    private static boolean loadedPathReceiver = false;
    private static boolean loadedPathList = false;

    public static void loadAllInterfaces() {
        if (loaded) {
            return;
        }

        loadTopologyPathProfile();
        loadTopologyPathManager();
        loadTopologyPathProxyManager();
        loadPathLookupSession();
        loadPathQuerySession();
        loadPathSearchSession();
        loadPathAdminSession();
        loadPathNotificationSession();
        loadPathGraphSession();
        loadPathGraphAssignmentSession();
        loadPathSmartGraphSession();
        loadPath();
        loadPathRecord();
        loadPathQuery();
        loadPathQueryRecord();
        loadPathQueryInspector();
        loadPathQueryInspectorRecord();
        loadPathForm();
        loadPathFormRecord();
        loadPathSearchOrder();
        loadPathSearchOrderRecord();
        loadPathSearch();
        loadPathSearchRecord();
        loadPathSearchResults();
        loadPathSearchResultsRecord();
        loadPathReceiver();
        loadPathList();
        loaded = true;
        loadedTopologyPathProfile = true;
        loadedTopologyPathManager = true;
        loadedTopologyPathProxyManager = true;
        loadedPathLookupSession = true;
        loadedPathQuerySession = true;
        loadedPathSearchSession = true;
        loadedPathAdminSession = true;
        loadedPathNotificationSession = true;
        loadedPathGraphSession = true;
        loadedPathGraphAssignmentSession = true;
        loadedPathSmartGraphSession = true;
        loadedPath = true;
        loadedPathRecord = true;
        loadedPathQuery = true;
        loadedPathQueryRecord = true;
        loadedPathQueryInspector = true;
        loadedPathQueryInspectorRecord = true;
        loadedPathForm = true;
        loadedPathFormRecord = true;
        loadedPathSearchOrder = true;
        loadedPathSearchOrderRecord = true;
        loadedPathSearch = true;
        loadedPathSearchRecord = true;
        loadedPathSearchResults = true;
        loadedPathSearchResultsRecord = true;
        loadedPathReceiver = true;
        loadedPathList = true;

        return;
    }


    public static void loadTopologyPathProfile() {
        if (loadedTopologyPathProfile) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.TopologyPathProfile");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathLookup");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathSearch");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathNotification");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathGraph");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathGraphAssignment");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathSmartGraph");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathRecordType");
        method.addParameter(new OsidParameter("pathRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearchRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathSearchRecordType");
        method.addParameter(new OsidParameter("pathSearchRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadTopologyPathManager() {
        if (loadedTopologyPathManager) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.TopologyPathManager");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("initialize");
        method.addParameter(new OsidParameter("runtime", "org.osid.OsidRuntimeManager", false));
        method.addError("org.osid.ConfigurationErrorException");
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("rollbackService");
        method.addParameter(new OsidParameter("rollbackTime", "java.util.Date", false, "timestamp"));
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntry", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changeBranch");
        method.addParameter(new OsidParameter("branchId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathLookup");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathSearch");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathNotification");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathGraph");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathGraphAssignment");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathSmartGraph");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathRecordType");
        method.addParameter(new OsidParameter("pathRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearchRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathSearchRecordType");
        method.addParameter(new OsidParameter("pathSearchRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathLookupSession");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathLookupSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathLookupSessionForGraph");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathLookupSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathQuerySession");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQuerySession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathQuerySessionForGraph");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQuerySession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearchSession");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathSearchSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearchSessionForGraph");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathSearchSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathAdminSession");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathAdminSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathAdminSessionForGraph");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathNotificationSession");
        method.addParameter(new OsidParameter("pathReceiver", "org.osid.topology.path.PathReceiver", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathNotificationSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathNotificationSessionForGraph");
        method.addParameter(new OsidParameter("pathReceiver", "org.osid.topology.path.PathReceiver", false));
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathNotificationSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathGraphSession");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathGraphSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathGraphAssignmentSession");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathGraphAssignmentSession", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathSmartGraphSession");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathSmartGraphSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadTopologyPathProxyManager() {
        if (loadedTopologyPathProxyManager) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.TopologyPathProxyManager");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProviderId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProvider");
        method.setReturn(new OsidReturn("org.osid.resource.Resource", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBrandingIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranding");
        method.setReturn(new OsidReturn("org.osid.repository.AssetList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLicense");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getVersion");
        method.setReturn(new OsidReturn("org.osid.installation.Version", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getReleaseDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsOSIDVersion");
        method.addParameter(new OsidParameter("version", "org.osid.installation.Version", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalRollback");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalBranching");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranchId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getBranch");
        method.setReturn(new OsidReturn("org.osid.journaling.Branch", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProxyRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsProxyRecordType");
        method.addParameter(new OsidParameter("proxyRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("initialize");
        method.addParameter(new OsidParameter("runtime", "org.osid.OsidRuntimeManager", false));
        method.addError("org.osid.ConfigurationErrorException");
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("rollbackService");
        method.addParameter(new OsidParameter("rollbackTime", "java.util.Date", false, "timestamp"));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntry", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changeBranch");
        method.addParameter(new OsidParameter("branchId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsVisibleFederation");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathLookup");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathSearch");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathAdmin");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathNotification");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathGraph");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathGraphAssignment");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathSmartGraph");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathRecordType");
        method.addParameter(new OsidParameter("pathRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearchRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsPathSearchRecordType");
        method.addParameter(new OsidParameter("pathSearchRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathLookupSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathLookupSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathLookupSessionForGraph");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathLookupSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathQuerySession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQuerySession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathQuerySessionForGraph");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQuerySession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearchSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathSearchSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearchSessionForGraph");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathSearchSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathAdminSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathAdminSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathAdminSessionForGraph");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathAdminSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathNotificationSession");
        method.addParameter(new OsidParameter("pathReceiver", "org.osid.topology.path.PathReceiver", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathNotificationSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathNotificationSessionForGraph");
        method.addParameter(new OsidParameter("pathReceiver", "org.osid.topology.path.PathReceiver", false));
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathNotificationSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathGraphSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathGraphSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathGraphAssignmentSession");
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathGraphAssignmentSession", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getPathSmartGraphSession");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("proxy", "org.osid.proxy.Proxy", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathSmartGraphSession", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathLookupSession() {
        if (loadedPathLookupSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathLookupSession");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getGraphId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGraph");
        method.setReturn(new OsidReturn("org.osid.topology.Graph", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canLookupPaths");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("useComparativePathView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("usePlenaryPathView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("useFederatedGraphView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("useIsolatedGraphView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("useEffectivePathView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("useAnyEffectivePathView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPath");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.Path", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByIds");
        method.addParameter(new OsidParameter("pathIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByGenusType");
        method.addParameter(new OsidParameter("pathGenusType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByParentGenusType");
        method.addParameter(new OsidParameter("pathGenusType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByRecordType");
        method.addParameter(new OsidParameter("pathRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsOnDate");
        method.addParameter(new OsidParameter("from", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("to", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByGenusTypeOnDate");
        method.addParameter(new OsidParameter("pathGenusType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("from", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("to", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsForStartingNode");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsForStartingNodeOnDate");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("from", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("to", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByGenusTypeForStartingNode");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("pathGenusType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByGenusTypeForStartingNodeOnDate");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("pathGenusType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("from", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("to", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsForEndingNode");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsForEndingNodeOnDate");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("from", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("to", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByGenusTypeForEndingNode");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("pathGenusType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByGenusTypeForEndingNodeOnDate");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("pathGenusType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("from", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("to", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsForNodes");
        method.addParameter(new OsidParameter("startingNodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("endingNodeId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsForNodesOnDate");
        method.addParameter(new OsidParameter("startingNodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("endingNodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("from", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("to", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByGenusTypeForNodes");
        method.addParameter(new OsidParameter("startingNodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("endingNodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("pathGenusType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByGenusTypeForNodesOnDate");
        method.addParameter(new OsidParameter("startingNodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("endingNodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("pathGenusType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("from", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("to", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsAlongNodes");
        method.addParameter(new OsidParameter("nodeIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsAlongNodesOnDate");
        method.addParameter(new OsidParameter("nodeIds", "org.osid.id.IdList", false));
        method.addParameter(new OsidParameter("from", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("to", "org.osid.calendaring.DateTime", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPaths");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathQuerySession() {
        if (loadedPathQuerySession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathQuerySession");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getGraphId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGraph");
        method.setReturn(new OsidReturn("org.osid.topology.Graph", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canSearchPaths");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("useFederatedGraphView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("useIsolatedGraphView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathQuery");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQuery", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByQuery");
        method.addParameter(new OsidParameter("pathQuery", "org.osid.topology.path.PathQuery", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathSearchSession() {
        if (loadedPathSearchSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathSearchSession");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getGraphId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGraph");
        method.setReturn(new OsidReturn("org.osid.topology.Graph", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canSearchPaths");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("useFederatedGraphView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("useIsolatedGraphView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathQuery");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQuery", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByQuery");
        method.addParameter(new OsidParameter("pathQuery", "org.osid.topology.path.PathQuery", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearch");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathSearch", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearchOrder");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathSearchOrder", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsBySearch");
        method.addParameter(new OsidParameter("pathQuery", "org.osid.topology.path.PathQuery", false));
        method.addParameter(new OsidParameter("pathSearch", "org.osid.topology.path.PathSearch", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathSearchResults", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathQueryFromInspector");
        method.addParameter(new OsidParameter("pathQueryInspector", "org.osid.topology.path.PathQueryInspector", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQuery", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathAdminSession() {
        if (loadedPathAdminSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathAdminSession");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getGraphId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGraph");
        method.setReturn(new OsidReturn("org.osid.topology.Graph", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreatePaths");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canCreatePathWithRecordTypes");
        method.addParameter(new OsidParameter("pathRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathFormForCreate");
        method.addParameter(new OsidParameter("startingNodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("endingNodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("pathRecordTypes", "org.osid.type.Type[]", true));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("createPath");
        method.addParameter(new OsidParameter("pathForm", "org.osid.topology.path.PathForm", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.Path", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canUpdatePaths");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathFormForUpdate");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathForm", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("updatePath");
        method.addParameter(new OsidParameter("pathForm", "org.osid.topology.path.PathForm", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canDeletePaths");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deletePath");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("addEdge");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("edgeId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("addEdges");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("edgeIds", "org.osid.id.IdList", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("removeEdge");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("edgeId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("removeEdges");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("edgeIds", "org.osid.id.IdList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManagePathAliases");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("aliasPath");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("aliasId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathNotificationSession() {
        if (loadedPathNotificationSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathNotificationSession");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getGraphId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGraph");
        method.setReturn(new OsidReturn("org.osid.topology.Graph", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canRegisterForPathNotifications");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("useFederatedGraphView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("useIsolatedGraphView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("reliablePathNotifications");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("unreliablePathNotifications");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("acknowledgePathNotification");
        method.addParameter(new OsidParameter("notificationId", "org.osid.id.Id", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForNewPaths");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForNewPathsByGenusType");
        method.addParameter(new OsidParameter("pathGenusType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForNewPathsForStartingNode");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForNewPathsForEndingNode");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForChangedPaths");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForChangedPathsByGenusType");
        method.addParameter(new OsidParameter("pathGenusType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForChangedPathsForStartingNode");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForChangedPathsForEndingNode");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForChangedPath");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForDeletedPaths");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForDeletedPathsByGenusType");
        method.addParameter(new OsidParameter("pathGenusType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForDeletedPathsForStartingNode");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForDeletedPathsForEndingNode");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("registerForDeletedPath");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathGraphSession() {
        if (loadedPathGraphSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathGraphSession");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("canLookupPathGraphMappings");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("useComparativePathGraphView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("usePlenaryPathGraphView");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathIdsByGraph");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByGraph");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathIdsByGraphs");
        method.addParameter(new OsidParameter("graphIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathsByGraphs");
        method.addParameter(new OsidParameter("graphIds", "org.osid.id.IdList", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGraphIdsByPath");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGraphsByPath");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.topology.GraphList", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathGraphAssignmentSession() {
        if (loadedPathGraphAssignmentSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathGraphAssignmentSession");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("canAssignPaths");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canAssignPathsToGraph");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAssignableGraphIds");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAssignableGraphIdsForPath");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("assignPathToGraph");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.addError("org.osid.AlreadyExistsException");
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("unassignPathFromGraph");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("reassignPathToGraph");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("fromGraphId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("toGraphId", "org.osid.id.Id", false));
        method.addError("org.osid.NotFoundException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathSmartGraphSession() {
        if (loadedPathSmartGraphSession) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathSmartGraphSession");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isAuthenticated");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAuthenticatedAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgentId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveAgent");
        method.setReturn(new OsidReturn("org.osid.authentication.Agent", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDate");
        method.setReturn(new OsidReturn("java.util.Date", false, "timestamp"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClockRate");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getFormatType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsTransactions");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("startTransaction");
        method.setReturn(new OsidReturn("org.osid.transaction.Transaction", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("getGraphId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGraph");
        method.setReturn(new OsidReturn("org.osid.topology.Graph", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("canManageSmartGraphs");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathQuery");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQuery", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearchOrder");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathSearchOrder", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("applyPathQuery");
        method.addParameter(new OsidParameter("pathQuery", "org.osid.topology.path.PathQuery", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("inspectPathQuery");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQueryInspector", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("applyPathSequencing");
        method.addParameter(new OsidParameter("pathSearchOrder", "org.osid.topology.path.PathSearchOrder", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathQueryFromInspector");
        method.addParameter(new OsidParameter("pathQueryInspector", "org.osid.topology.path.PathQueryInspector", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQuery", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPath() {
        if (loadedPath) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.Path");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProperties");
        method.setReturn(new OsidReturn("org.osid.PropertyList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPropertiesByRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.PropertyList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayName");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescription");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusType");
        method.setReturn(new OsidReturn("org.osid.type.Type", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isOfGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isEffective");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndDate");
        method.setReturn(new OsidReturn("org.osid.calendaring.DateTime", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasEndReason");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndReasonId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndReason");
        method.setReturn(new OsidReturn("org.osid.process.State", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartingNodeId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartingNode");
        method.setReturn(new OsidReturn("org.osid.topology.Node", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndingNodeId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndingNode");
        method.setReturn(new OsidReturn("org.osid.topology.Node", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isComplete");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isClosed");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getHops");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDistance");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCost");
        method.setReturn(new OsidReturn("java.math.BigDecimal", false, "decimal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEdgeIds");
        method.setReturn(new OsidReturn("org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEdges");
        method.setReturn(new OsidReturn("org.osid.topology.EdgeList", false));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathRecord");
        method.addParameter(new OsidParameter("pathRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.records.PathRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathRecord() {
        if (loadedPathRecord) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.records.PathRecord");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("implementsRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathQuery() {
        if (loadedPathQuery) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathQuery");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getStringMatchTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsStringMatchType");
        method.addParameter(new OsidParameter("stringMatchType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchKeyword");
        method.addParameter(new OsidParameter("keyword", "String", false, "string"));
        method.addParameter(new OsidParameter("stringMatchType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearKeywordTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAny");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearAnyTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStringMatchTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsStringMatchType");
        method.addParameter(new OsidParameter("stringMatchType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchKeyword");
        method.addParameter(new OsidParameter("keyword", "String", false, "string"));
        method.addParameter(new OsidParameter("stringMatchType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearKeywordTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAny");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearAnyTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStringMatchTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsStringMatchType");
        method.addParameter(new OsidParameter("stringMatchType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchKeyword");
        method.addParameter(new OsidParameter("keyword", "String", false, "string"));
        method.addParameter(new OsidParameter("stringMatchType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearKeywordTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAny");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearAnyTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchId");
        method.addParameter(new OsidParameter("id", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyRecord");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearRecordTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStringMatchTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsStringMatchType");
        method.addParameter(new OsidParameter("stringMatchType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchKeyword");
        method.addParameter(new OsidParameter("keyword", "String", false, "string"));
        method.addParameter(new OsidParameter("stringMatchType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearKeywordTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAny");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearAnyTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addParameter(new OsidParameter("stringMatchType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyDisplayName");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayNameTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addParameter(new OsidParameter("stringMatchType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyDescription");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescriptionTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyGenusType");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusTypeTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchParentGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearParentGenusTypeTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchSubjectId");
        method.addParameter(new OsidParameter("subjectId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearSubjectIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsSubjectQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getSubjectQuery");
        method.setReturn(new OsidReturn("org.osid.ontology.SubjectQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("matchAnySubject");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearSubjectTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsSubjectRelevancyQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getSubjectRelevancyQuery");
        method.setReturn(new OsidReturn("org.osid.ontology.RelevancyQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("clearSubjectRelevancyTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchStateId");
        method.addParameter(new OsidParameter("stateId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStateIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsStateQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStateQuery");
        method.setReturn(new OsidReturn("org.osid.process.StateQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyState");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStateTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchCommentId");
        method.addParameter(new OsidParameter("commentId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCommentIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsCommentQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCommentQuery");
        method.setReturn(new OsidReturn("org.osid.commenting.CommentQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyComment");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCommentTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchJournalEntryId");
        method.addParameter(new OsidParameter("journalEntryId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearJournalEntryIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsJournalEntryQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalEntryQuery");
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntryQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyJournalEntry");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearJournalEntryTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsStatisticQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStatisticQuery");
        method.setReturn(new OsidReturn("org.osid.metering.StatisticQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyStatistic");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStatisticTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchCreditId");
        method.addParameter(new OsidParameter("creditId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCreditIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsCreditQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCreditQuery");
        method.setReturn(new OsidReturn("org.osid.acknowledgement.CreditQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyCredit");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCreditTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchRelationshipId");
        method.addParameter(new OsidParameter("relationshipId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearRelationshipIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsRelationshipQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipQuery");
        method.setReturn(new OsidReturn("org.osid.relationship.RelationshipQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyRelationship");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearRelationshipTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchRelationshipPeerId");
        method.addParameter(new OsidParameter("peerId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearRelationshipPeerIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchEffective");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEffectiveTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchStartDate");
        method.addParameter(new OsidParameter("start", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("end", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyStartDate");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStartDateTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchEndDate");
        method.addParameter(new OsidParameter("start", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("end", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyEndDate");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEndDateTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchDate");
        method.addParameter(new OsidParameter("from", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("to", "org.osid.calendaring.DateTime", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDateTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStringMatchTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsStringMatchType");
        method.addParameter(new OsidParameter("stringMatchType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchKeyword");
        method.addParameter(new OsidParameter("keyword", "String", false, "string"));
        method.addParameter(new OsidParameter("stringMatchType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearKeywordTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAny");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearAnyTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchEndReasonId");
        method.addParameter(new OsidParameter("stateId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEndReasonIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsEndReasonQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndReasonQuery");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setReturn(new OsidReturn("org.osid.process.StateQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyEndReason");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEndReasonTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchComplete");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCompleteTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchClosed");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearClosedTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchStartingNodeId");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStartingNodeIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsStartingNodeQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartingNodeQuery");
        method.setReturn(new OsidReturn("org.osid.topology.NodeQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("clearStartingNodeTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchEndingNodeId");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEndingNodeIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsEndingNodeQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndingNodeQuery");
        method.setReturn(new OsidReturn("org.osid.topology.NodeQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("clearEndingNodeTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAlongNodeIds");
        method.addParameter(new OsidParameter("nodeIds", "org.osid.id.Id[]", true));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearAlongNodeIdsTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchIntersectingPathId");
        method.addParameter(new OsidParameter("pathId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearIntersectingPathIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsIntersectingPathQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getIntersectingPathQuery");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyIntersectingPath");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearIntersectingPathTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchHops");
        method.addParameter(new OsidParameter("from", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("to", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearHopsTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchDistance");
        method.addParameter(new OsidParameter("from", "java.math.BigDecimal", false, "decimal"));
        method.addParameter(new OsidParameter("to", "java.math.BigDecimal", false, "decimal"));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchAnyDistance");
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDistanceTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchCost");
        method.addParameter(new OsidParameter("from", "java.math.BigDecimal", false, "decimal"));
        method.addParameter(new OsidParameter("to", "java.math.BigDecimal", false, "decimal"));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.InvalidArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearCostTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchNodeId");
        method.addParameter(new OsidParameter("nodeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearNodeIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsNodeQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNodeQuery");
        method.setReturn(new OsidReturn("org.osid.topology.NodeQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("clearNodeTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchEdgeId");
        method.addParameter(new OsidParameter("edgeId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEdgeIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsEdgeQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEdgeQuery");
        method.setReturn(new OsidReturn("org.osid.topology.EdgeQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("clearEdgeTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("matchGraphId");
        method.addParameter(new OsidParameter("graphId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("match", "boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGraphIdTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsGraphQuery");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGraphQuery");
        method.setReturn(new OsidReturn("org.osid.topology.GraphQuery", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("clearGraphTerms");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathQueryRecord");
        method.addParameter(new OsidParameter("pathRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.records.PathQueryRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathQueryRecord() {
        if (loadedPathQueryRecord) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.records.PathQueryRecord");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("implementsRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathQueryInspector() {
        if (loadedPathQueryInspector) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathQueryInspector");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getKeywordTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.StringTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAnyTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.BooleanTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getKeywordTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.StringTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAnyTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.BooleanTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getKeywordTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.StringTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAnyTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.BooleanTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypeTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.TypeTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getKeywordTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.StringTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAnyTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.BooleanTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.StringTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.StringTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.TypeTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getParentGenusTypeTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.TypeTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getSubjectIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getSubjectTerms");
        method.setReturn(new OsidReturn("org.osid.ontology.SubjectQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getSubjectRelevancyTerms");
        method.setReturn(new OsidReturn("org.osid.ontology.RelevancyQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStateIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStateTerms");
        method.setReturn(new OsidReturn("org.osid.process.StateQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCommentIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCommentTerms");
        method.setReturn(new OsidReturn("org.osid.commenting.CommentQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalEntryIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalEntryTerms");
        method.setReturn(new OsidReturn("org.osid.journaling.JournalEntryQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStatisticTerms");
        method.setReturn(new OsidReturn("org.osid.metering.StatisticQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCreditIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCreditTerms");
        method.setReturn(new OsidReturn("org.osid.acknowledgement.CreditQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipTerms");
        method.setReturn(new OsidReturn("org.osid.relationship.RelationshipQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRelationshipPeerIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEffectiveTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.BooleanTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartDateTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.DateTimeRangeTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndDateTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.DateTimeRangeTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDateTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.DateTimeRangeTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getKeywordTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.StringTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAnyTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.BooleanTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndReasonIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndReasonTerms");
        method.setReturn(new OsidReturn("org.osid.process.StateQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCompleteTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.BooleanTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getClosedTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.BooleanTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartingNodeIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartingNodeTerms");
        method.setReturn(new OsidReturn("org.osid.topology.NodeQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndingNodeIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndingNodeTerms");
        method.setReturn(new OsidReturn("org.osid.topology.NodeQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getAlongNodeIdsTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdSetTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getIntersectingPathIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getIntersectingPathTerms");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getHopsTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.CardinalRangeTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDistanceTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.DecimalRangeTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getCostTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.DecimalRangeTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNodeIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNodeTerms");
        method.setReturn(new OsidReturn("org.osid.topology.NodeQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEdgeIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEdgeTerms");
        method.setReturn(new OsidReturn("org.osid.topology.EdgeQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGraphIdTerms");
        method.setReturn(new OsidReturn("org.osid.search.terms.IdTerm[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGraphTerms");
        method.setReturn(new OsidReturn("org.osid.topology.GraphQueryInspector[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathQueryInspectorRecord");
        method.addParameter(new OsidParameter("pathRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.records.PathQueryInspectorRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathQueryInspectorRecord() {
        if (loadedPathQueryInspectorRecord) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.records.PathQueryInspectorRecord");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("implementsRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathForm() {
        if (loadedPathForm) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathForm");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getRequiredRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDisplayNameMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDisplayName");
        method.addParameter(new OsidParameter("displayName", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDisplayName");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDescriptionMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setDescription");
        method.addParameter(new OsidParameter("description", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearDescription");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getGenusTypeMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setGenusType");
        method.addParameter(new OsidParameter("genusType", "org.osid.type.Type", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearGenusType");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setStartDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearStartDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndDateMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setEndDate");
        method.addParameter(new OsidParameter("date", "org.osid.calendaring.DateTime", false));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("clearEndDate");
        method.addError("org.osid.NoAccessException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getId");
        method.setReturn(new OsidReturn("org.osid.id.Id", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isCurrent");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isForUpdate");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getDefaultLocale");
        method.setReturn(new OsidReturn("org.osid.locale.Locale", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getLocales");
        method.setReturn(new OsidReturn("org.osid.locale.LocaleList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setLocale");
        method.addParameter(new OsidParameter("languageType", "org.osid.type.Type", false));
        method.addParameter(new OsidParameter("scriptType", "org.osid.type.Type", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getJournalCommentMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("setJournalComment");
        method.addParameter(new OsidParameter("comment", "String", false, "string"));
        method.addError("org.osid.InvalidArgumentException");
        method.addError("org.osid.NoAccessException");
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("isValid");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getValidationMessages");
        method.setReturn(new OsidReturn("org.osid.locale.DisplayText[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getInvalidMetadata");
        method.setReturn(new OsidReturn("org.osid.Metadata[]", true));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathFormRecord");
        method.addParameter(new OsidParameter("pathRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.records.PathFormRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathFormRecord() {
        if (loadedPathFormRecord) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.records.PathFormRecord");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("implementsRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathSearchOrder() {
        if (loadedPathSearchOrder) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathSearchOrder");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderById");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByDisplayName");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByDescription");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByGenusType");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByState");
        method.addParameter(new OsidParameter("processId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByCumulativeRating");
        method.addParameter(new OsidParameter("bookId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByStatistic");
        method.addParameter(new OsidParameter("meterId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByCreateTime");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByLastModifiedTime");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByEffective");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByStartDate");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByEndDate");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByEndReason");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsEndReasonSearchOrder");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndReasonSearchOrder");
        method.setReturn(new OsidReturn("org.osid.process.StateSearchOrder", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("orderByStartingNode");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsStartingNodeSearchOrder");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getStartingNodeSearchOrder");
        method.setReturn(new OsidReturn("org.osid.topology.NodeSearchOrder", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("orderByEndingNode");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("supportsEndingNodeSearchOrder");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getEndingNodeSearchOrder");
        method.setReturn(new OsidReturn("org.osid.topology.NodeSearchOrder", false));
        method.addError("org.osid.UnimplementedException");
        method.setMandatory(false);
        iface.addMethod(method);

        method = new OsidMethod("orderByComplete");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByClosed");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByHops");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByDistance");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderByCost");
        method.addParameter(new OsidParameter("style", "org.osid.SearchOrderStyle"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearchOrderRecord");
        method.addParameter(new OsidParameter("pathRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.records.PathSearchOrderRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathSearchOrderRecord() {
        if (loadedPathSearchOrderRecord) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.records.PathSearchOrderRecord");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("implementsRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathSearch() {
        if (loadedPathSearch) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathSearch");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("limitResultSet");
        method.addParameter(new OsidParameter("start", "long", false, "cardinal"));
        method.addParameter(new OsidParameter("end", "long", false, "cardinal"));
        method.addError("org.osid.InvalidArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("searchAmongPaths");
        method.addParameter(new OsidParameter("pathIds", "org.osid.id.IdList", false));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("orderPathResults");
        method.addParameter(new OsidParameter("pathSearchOrder", "org.osid.topology.path.PathSearchOrder", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearchRecord");
        method.addParameter(new OsidParameter("pathSearchRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.records.PathSearchRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathSearchRecord() {
        if (loadedPathSearchRecord) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.records.PathSearchRecord");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("implementsRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathSearchResults() {
        if (loadedPathSearchResults) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathSearchResults");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("getRecordTypes");
        method.setReturn(new OsidReturn("org.osid.type.TypeList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("hasRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getProperties");
        method.setReturn(new OsidReturn("org.osid.PropertyList", false));
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPropertiesByRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.PropertyList", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.PermissionDeniedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getResultSize");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPaths");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathList", false));
        method.addError("org.osid.IllegalStateException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathQueryInspector");
        method.setReturn(new OsidReturn("org.osid.topology.path.PathQueryInspector", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getPathSearchResultsRecord");
        method.addParameter(new OsidParameter("pathSearchRecordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("org.osid.topology.path.records.PathSearchResultsRecord", false));
        method.addError("org.osid.NullArgumentException");
        method.addError("org.osid.OperationFailedException");
        method.addError("org.osid.UnsupportedException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathSearchResultsRecord() {
        if (loadedPathSearchResultsRecord) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.records.PathSearchResultsRecord");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("implementsRecordType");
        method.addParameter(new OsidParameter("recordType", "org.osid.type.Type", false));
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.addError("org.osid.NullArgumentException");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathReceiver() {
        if (loadedPathReceiver) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathReceiver");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("up");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("down");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("newPaths");
        method.addParameter(new OsidParameter("notificationId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("pathIds", "org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("changedPaths");
        method.addParameter(new OsidParameter("notificationId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("pathIds", "org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("deletedPaths");
        method.addParameter(new OsidParameter("notificationId", "org.osid.id.Id", false));
        method.addParameter(new OsidParameter("pathIds", "org.osid.id.IdList", false));
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }


    public static void loadPathList() {
        if (loadedPathList) {
            return;
        }

        OsidMethod method;
        Osids osids = Osids.getInstance();

        OsidInterface iface = new OsidInterface("org.osid.topology.path.PathList");
        osids.getOsid("org.osid.topology.path").addInterface(iface);
        method = new OsidMethod("hasNext");
        method.setReturn(new OsidReturn("boolean", false, "boolean"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("available");
        method.setReturn(new OsidReturn("long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("skip");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextPath");
        method.setReturn(new OsidReturn("org.osid.topology.path.Path", false));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("getNextPaths");
        method.addParameter(new OsidParameter("n", "long", false, "cardinal"));
        method.setReturn(new OsidReturn("org.osid.topology.path.Path[]", true));
        method.addError("org.osid.IllegalStateException");
        method.addError("org.osid.OperationFailedException");
        method.setMandatory(true);
        iface.addMethod(method);

        method = new OsidMethod("close");
        method.setMandatory(true);
        iface.addMethod(method);

        return;
    }
}
